
/**
 **
clear
set mem 1000m
set more off

use rand_panel_restricted

sort hhidpn year
merge hhidpn year using /tmp/cams.dta
tab year _merge
drop if _merge == 2
 **
 **/

** house
** observed hosing value * 0.0715
**  + property tax
**  + homeowner insurance
**  + depreciation (0.0214 * observed value)
gen house_flow = B_mortgage + B_tax + B_home_ins + B_rent


** auto
** (TODO!) (need to update HRS raw data)


** other "big ticket" items
** following Hurd ...

** (1) logit to predict purchase on age, income,
**      marital status, household size, wave
** (2) predict log(spending) conditional on purchse (same covariates)
** (3) predict avg annual consumption: p_hat * log_spending_hat

rename B_lease B_car
rename B_auto_a_price B_car_price

foreach var of varlist B_fridge B_washer B_dishwasher B_tv B_computer B_car {

capture drop *p_hat 

xi i.year
logit B_fridge rage log_inc_perm single hh_size _Iye*
predict p_hat, pr

capture drop log_p
gen log_p = log(`var'_price)
reg log_p rage rageSquared log_inc_perm single isfemale isblack hh_size _Iye*
predict log_p_hat, xb

gen `var'_flow = p_hat * exp(log_p_hat) if `var' < .
summ `var' `var'_price
summ `var'_flow if `var' < ., det

}

replace B_home_maintain = ///
 cond(B_home_maintain < ., B_home_maintain, 0) + ///
 cond(B_home_maintain_diy < ., B_home_maintain_diy, 0) + ///
 cond(B_home_maintain_pro < ., B_home_maintain_pro, 0) 
drop B_home_maintain_pro B_home_maintain_diy

replace B_gifts = ///
 cond(B_gifts < ., B_gifts, 0) + ///
 cond(B_contribs < ., B_contribs, 0) 
rename B_gifts gifts_flow

foreach var of varlist B_tickets B_clothing B_hobbies {
 replace `var' = `var' / 12 if wave == 6 
 replace `var' = `var' / 12 if wave == 7
}

foreach var of varlist B_vehicle_service {
 replace `var' = `var' / 52 if `var' > 8000 & `var' < .
}

foreach var of varlist B_electricity {
 replace `var' = `var' / 12 if `var' > 100000 & `var' < .
 bys hhidpn: egen min_`var' = min(`var')
 bys hhidpn: egen max_`var' = max(`var')
 replace `var' = `var' * 12 if max_`var' == 7200 & `var' < 1000 
 replace `var' = floor(`var' / 12) if `var' == 11867 & max_`var' == 11867
}

foreach var of varlist B_water {
 replace `var' = `var' / 12 if `var' > 20000 & `var' < .
}


summ B_electricity

summ B_vehicle_service B_home_maintain, det
foreach var of varlist B_auto_finance B_vehicle_service B_home_maintain {
 bys hhidpn: egen mean_`var' = mean(`var')
 *replace `var' = mean_`var' if `var' < .
 drop mean_`var'
}




egen nondurable_flow2 =  rowtotal(  ///
  B_electricity B_water B_heat B_phone_cable ///
  B_auto_ins ///
  B_food B_dining_out B_clothing ///
  B_gas B_house_supply ///
  B_vacations B_tickets B_hobbies ///
  B_cleaning B_housekeeping B_garden_supply B_garden_svc B_sports_equipment ///
  )

foreach var of varlist B_electricity B_water B_heat {
 sort hhidpn year
  *by hhidpn: replace `var' = `var'[_n + 1] if `var' >= . & `var'[_n + 1] < . & wave <= 5
}



** "Hot deck"
egen nonmiss_all = rownonmiss( ///
  B_electricity B_water B_heat B_phone_cable ///
  B_auto_finance B_auto_ins B_house_supply ///
  B_home_maintain B_food B_dining_out B_clothing ///
  B_gas B_vehicle_service ///
  B_vacations B_tickets B_hobbies ///
  B_cleaning B_housekeeping B_garden_supply B_garden_svc B_sports_equipment)

foreach var of varlist ///
  B_electricity B_water B_heat B_phone_cable ///
  B_auto_finance B_auto_ins B_house_supply ///
  B_home_maintain B_food B_dining_out B_clothing ///
  B_gas B_vehicle_service ///
  B_vacations B_tickets B_hobbies ///
  B_cleaning B_housekeeping B_garden_supply B_garden_svc B_sports_equipment {
/**
 capture drop log_p
 capture drop log_p_hat
 gen log_p = log(`var')
 reg log_p rage rageSquared log_inc_perm single isfemale isblack hh_size _Iye*
 predict log_p_hat 

 capture drop p_flow
 gen p_flow = exp(log_p_hat)
 *replace `var' = p_flow if `var' >= . & nonmiss_all > 1
 **/

}

 



egen nondurable_flow =  rowtotal(  ///
  B_electricity B_water B_heat B_phone_cable ///
  B_auto_finance B_auto_ins B_house_supply ///
  B_home_maintain B_food B_dining_out B_clothing ///
  B_gas B_vehicle_service ///
  B_vacations B_tickets B_hobbies ///
  B_cleaning B_housekeeping B_garden_supply B_garden_svc B_sports_equipment )





*count if nondurable_flow == 0
*assert( r(N) / _N < 0.02)
*drop if nondurable_flow == 0
replace nondurable_flow = . ///
 if nondurable_flow == 0 | nondurable_flow2 == 0

drop nondurable_flow2

egen nonmiss_health = rownonmiss(B_drugs B_health_svc B_medical_supply B_health_ins)
gen health_flow = ///
 cond(B_drugs < ., B_drugs, 0) + ///
 cond(B_health_svc < ., B_health_svc, 0) + ///
 cond(B_medical_supply < ., B_medical_supply, 0) + ///
 cond(B_health_ins < ., B_health_ins, 0)

desc *_flow, full
summ *_flow, det
egen nonmiss = rownonmiss(*_flow)
egen total_consumption_flow = rowtotal(*_flow) if nonmiss > 1

**
* Combine across hhid's
**
sort hhid wave hhidpn
foreach var of varlist health_flow total_consumption_flow nondurable_flow gifts_flow {
 rename `var' `var'tmp
 by hhid wave: egen `var' = sum(`var'tmp)
 drop `var'tmp
 **by hhid wave: replace `var' = . if _n > 1
}



gen log_h = log(1 + health_flow) if nonmiss > 1
gen log_c = log(total_consumption_flow)
gen log_c_nd     = log(nondurable_flow + health_flow + gifts_flow)

replace log_h = log(1 + health_flow / 1.7) if nonmiss > 1 & single != 1
replace log_c = log(total_consumption_flow / 1.7) if single != 1
replace log_c_nd     = log((nondurable_flow + health_flow + gifts_flow) / 1.7) if single != 1

gen log_c_no_h    = log((total_consumption_flow - health_flow)/1.0)
gen log_c_nd_no_h    = log((nondurable_flow + gifts_flow)/1.0)
replace log_c_no_h    = log((total_consumption_flow - health_flow)/1.7) if single != 1
replace log_c_nd_no_h    = log((nondurable_flow + gifts_flow)/1.7) if single != 1

replace log_h = . if ///
 missing(B_drugs) & ///
 missing(B_health_svc) & ///
 missing(B_medical_supply) & ///
 missing(B_health_ins)

gen log_c_nd_no_h_g = log(nondurable_flow)
gen log_c_no_h_g = log(total_consumption_flow - gifts_flow - health_flow)
gen sqrt_h = sqrt(1 + health_flow) if nonmiss > 1

gen log_c_dining   = log(1 + B_dining_out)
gen log_c_vacations= log(1 + B_vacations)
gen B_leisure = (B_dining_out + B_vacations + B_tickets + B_hobbies + cond(B_sports_equipment < ., B_sports_equipment, 0))
gen log_c_leisure  = log(1 + B_leisure)
gen log_c_gifts    = log(1 + gifts_flow)

gen log_home_maintain = log(1 + B_home_maintain)
egen B_total_food = rowtotal(B_food B_dining_out) if nonmiss > 1
gen log_total_food    = log(1 + B_total_food)
egen B_chores  = rowtotal(B_cleaning B_housekeeping B_house_supply B_home_maintain B_garden_svc B_garden_supply) if nonmiss > 1
gen log_chores = log(1 + B_chores)

summ total_consumption_flow health_flow



