
clear mata

*global PHI_2_TILDE = 1e20 * $PHI_2_TILDE 
global PHI_2_TILDE = $PHI_2_TILDE 

mata:

C2_sick0 = st_matrix("C2_sick0")
H2_sick0 = st_matrix("H2_sick0")
ones = st_matrix("ones")

void mysolver2(todo, p, C2_sick0, H2_sick0, ones, lnf, S, H)
 {

  //p

  PHI_1_TILDE = p[1,1]
  PHI_2_TILDE = p[1,2]

  //PHI_2_temp = (1+PHI_1_TILDE) * (PHI_2_TILDE*$PHI_2_TILDE) * (($C2_sick0)^(1+1/$EPS) + (PHI_2_TILDE*$PHI_2_TILDE)*(($H2_sick0)^(1+1/$EPS)))^((1-$GAMMA)/(1+1/$EPS)-1)
  //PHI_1_temp = (1+PHI_1_TILDE) * (1 + (PHI_2_TILDE*$PHI_2_TILDE)*(($H2_sick0 / $C2_sick0)^(1+1/$EPS)))^((1-$GAMMA)/(1+1/$EPS)-1) - 1

  PHI_2_temp = (1+PHI_1_TILDE) :* (PHI_2_TILDE:*$PHI_2_TILDE) :* ((C2_sick0):^(1+1/$EPS) :+ (PHI_2_TILDE:*$PHI_2_TILDE):*((H2_sick0):^(1+1/$EPS))):^((1-$GAMMA)/(1+1/$EPS)-1)
  PHI_1_temp = (1+PHI_1_TILDE) :* (1 :+ (PHI_2_TILDE:*$PHI_2_TILDE):*((H2_sick0 :/ C2_sick0):^(1+1/$EPS))):^((1-$GAMMA)/(1+1/$EPS)-1) :- 1

  PHI_1_temp = (PHI_1_temp' * ones) / rows(ones)
  PHI_2_temp = (PHI_2_temp' * ones) / rows(ones)

  d1 = ((PHI_1_temp - $PHI_1)/$PHI_1)^2
  d2 = ((PHI_2_temp - $PHI_2)/$PHI_2)^2 
  lnf = 1e10 * (d1 + d2)

/**
  ones = 111111
  ones
  $PHI_1
  PHI_1_temp
  $PHI_2
  PHI_2_temp
  d1
  d2
  //p
  lnf
 **/
 }

S = optimize_init()
optimize_init_evaluator(S, &mysolver2())
optimize_init_evaluatortype(S, "d0")
optimize_init_conv_ptol(S, 1e-30)
optimize_init_conv_vtol(S, 1e-30)
//optimize_init_technique(S, "bhhh")
optimize_init_which(S, "min")
optimize_init_tracelevel(S, "none")

optimize_init_argument(S, 1, C2_sick0)
optimize_init_argument(S, 2, H2_sick0)
optimize_init_argument(S, 3, ones)

$PHI_1_TILDE
$PHI_2_TILDE

optimize_init_conv_maxiter(S, 200)
results = J(0,5,0)
for(i = 0; i<= 20; i++) {
 inits = uniform(1,2)
 inits = 1 :* inits :- 0.5
 inits
 optimize_init_params(S, inits)
 //rc = _optimize(S)
 rc = _optimize(S)
 rc
 if (rc == 0) {
  converged = optimize_result_converged(S)
  p = optimize_result_params(S)
  mWm = optimize_result_value(S)
  iters = optimize_result_iterations(S)
  out = (p, converged, mWm, iters)
  results = (results \ out)
  results = sort(results, (-3, 4))
  results
  if (results[1,3] == 1) {
   break
  }
 }
}
assert(results[1,3] == 1)

s1 = results[1,1]
s2 = results[1,2] * $PHI_2_TILDE

st_numscalar("PHI_1_TILDE", s1)
st_numscalar("PHI_2_TILDE", s2)

end

exit


