 
clear mata

mata:

void mysolver(todo, s, data, lnf, S, H)
 {

 // NOTE: s is savings
 //  c1 = (1-tau)*Y-saving
 
 // vector of 25-year cumulative rates
 r_cum = data[1...,1]

 // wealth at start of second period

 tau = $TAU

 W = (1 :+ r_cum) :* s
 //W = (1 :+ r_cum) :* ((1-(tau))*s)

 ones = J(rows(r_cum),1,1)


 // Summary of algorithm
 //
 // Step 1: calculate expected utility

 C2_sick = W :/ (1 + ((1-($b))^(1+$EPS))*(($PHI_2_TILDE)^(-1*$EPS)))

 H2_sick  = (W :- C2_sick) :/ (1-($b))

 if ($GAMMA != 1) {
  U2_healthy = (1/(1-$GAMMA)) :* (W :^ (1-$GAMMA))
  //U2_healthy = (1/(1-$GAMMA)) :* ( (W :* (1-($TAU))) :^ (1-$GAMMA))
  U2_sick    = $PHI_0 :+ ///
      (1/(1-$GAMMA)) :* (1+$PHI_1_TILDE) :* ( ((C2_sick :^ (1+1/$EPS)) :+ ($PHI_2_TILDE) :* ((H2_sick) :^ (1+1/$EPS)) ) :^ ((1-$GAMMA)/(1+1/$EPS)) )
 }
 else {
  U2_healthy = log(W)
  U2_sick    = $PHI_0 :+ ///
      (1+$PHI_1_TILDE) :* log( ((C2_sick :^ (1+1/$EPS)) :+ ($PHI_2_TILDE) :* ((H2_sick) :^ (1+1/$EPS)) ) :^ (1/(1+1/$EPS)) )
 }

 ones = J(rows(U2_healthy), 1, 1)
 E_U2 =    $p  * (U2_healthy' * ones) / rows(U2_healthy) + ///
        (1-$p) * (U2_sick'    * ones) / rows(U2_sick)

 c1 = (1-tau)*$Y - s
 //c1 = $Y - (1-tau)*s
 //c1 = (1-tau)*($Y - s)
 //c1 = $Y - s

 if (abs($GAMMA - $THETA) < 1e-5) {
/**
 **
  U = (1/(1-$GAMMA)) * ///
     ( (c1)^(1-$THETA) + ///
       (1/(1+$DELTA_CUM)) * ((1-$GAMMA)*E_U2) ///
     )
 **
 **/
  U = (1/(1-$GAMMA)) * ///
    ( (c1)^(1-$THETA) + ///
      (1/(1+$DELTA_CUM)) * (((1-$GAMMA)*E_U2)^((1-$THETA)/(1-$GAMMA))) ///
    )^((1-$GAMMA)/(1-$THETA))
 }
 else {
  if ($GAMMA != 1) {
   U = (1/(1-$GAMMA)) * ///
     ( (c1)^(1-$THETA) + ///
       (1/(1+$DELTA_CUM)) * (((1-$GAMMA)*E_U2)^((1-$THETA)/(1-$GAMMA))) ///
     )^((1-$GAMMA)/(1-$THETA))
  }
  else {
   U = log( ///
     ( (c1)^(1-$THETA) + ///
       (1/(1+$DELTA_CUM)) * ((exp(E_U2))^((1-$THETA))) ///
     )^(1/(1-$THETA))  )

  }
 }

 lnf = U 

}

r_cum = st_data(., ("r_cum"))
data = (r_cum)

S = optimize_init()
optimize_init_evaluator(S, &mysolver())
optimize_init_evaluatortype(S, "v0")
optimize_init_conv_ptol(S, 1e-30)
optimize_init_conv_vtol(S, 1e-30)
//optimize_init_technique(S, "bhhh")
optimize_init_which(S, "max")
optimize_init_argument(S, 1, data)
optimize_init_tracelevel(S, "none")

optimize_init_conv_maxiter(S, 200)

if ($s_fixed < .) {

s = $s_fixed
ones = J(rows(r_cum),1,1)
W = (1 :+ r_cum) :* s
//W = (1 :+ r_cum) :* ((1-($TAU))*s)
C2_sick = W :/ (1 + ((1-($b))^(1+$EPS))*(($PHI_2_TILDE)^(-1*$EPS)))
H2_sick  = (W :- C2_sick) :/ (1-($b))
//tau = ( ((1-$p) :* $b :* ( H2_sick ) :/ (1 :+ r_cum))' * ones ) / rows(r_cum)
tau = $TAU

 U2_healthy = (1/(1-$GAMMA)) :* (W :^ (1-$GAMMA))
 //U2_healthy = (1/(1-$GAMMA)) :* ((W :* (1-$TAU)) :^ (1-$GAMMA))
 U2_sick    = $PHI_0 :+ ///
      (1/(1-$GAMMA)) :* (1+$PHI_1_TILDE) :* ((C2_sick :^ (1+1/$EPS)) :+ ($PHI_2_TILDE) :* ((H2_sick) :^ (1+1/$EPS)) ) :^ ((1-$GAMMA)/(1+1/$EPS))

ones = J(rows(U2_healthy), 1, 1)
E_U2 =    $p  * (U2_healthy' * ones) / rows(U2_healthy) + ///
       (1-$p) * (U2_sick'    * ones) / rows(U2_sick)

c1 = (1-tau)*$Y - s
//c1 = $Y - (1-tau)*s
//c1 = (1-tau)*($Y - s)
//c1 = $Y - s

U = (1/(1-$GAMMA)) * ///
     ( (c1)^(1-$THETA) + ///
       (1/(1+$DELTA_CUM)) * (((1-$GAMMA)*E_U2)^((1-$THETA)/(1-$GAMMA))) ///
     )^((1-$GAMMA)/(1-$THETA))
mWm = U 

}
else {


results = J(0,4,0)
for(i = 1; i<= 100; i++) {
 s_init = i / 99
 optimize_init_params(S, (s_init))
 rc = _optimize(S)
 converged = optimize_result_converged(S)
 s = optimize_result_params(S)
 mWm = optimize_result_value(S)
 if (rc == 0) {
  converged = optimize_result_converged(S)
  p = optimize_result_params(S)
  mWm = optimize_result_value(S)
  iters = optimize_result_iterations(S)
  out = (p, converged, mWm, iters)
  results = (results \ out)
  results = sort(results, (-2, 3))
  results
  if (i >= 10) {
   if (results[2,2] == 1) {
    break
   }
  }
 }
}
st_matrix("results", results)
assert(results[2,2] == 1)

converged = results[1,2]
mWm = results[1,3]
s = results[1,1]

}



//check
ones = J(rows(r_cum),1,1)
W = (1 :+ r_cum) :* s
//W = (1 :+ r_cum) :* ((1-($TAU))*s)
C2_healthy0 = W 
C2_sick0 = W :/ (1 + ((1-($b))^(1+$EPS))*(($PHI_2_TILDE)^(-1*$EPS)))
H2_sick0  = (W :- C2_sick0) :/ (1-($b))
tau = ( ((1-$p) :* $b :* ( H2_sick0 ) :/ (1 :+ r_cum))' * ones ) / rows(r_cum) 
//tau = ( ( ((1-$p) :* $b :* ( H2_sick0 ) :/ (1 :+ r_cum))' * ones ) / rows(r_cum) ) / ($p * W)
tau
c1 = (1-($TAU))*$Y - s
//c1 = $Y - (1-($TAU))*s
//c1 = $Y - s

c1
s

st_numscalar("s_hat", s)
st_numscalar("tau_hat", tau)	
st_numscalar("U", mWm)

//C2_sick0 = (C2_sick0' * ones) / rows(C2_sick0)
//H2_sick0 = (H2_sick0' * ones) / rows(H2_sick0)
//st_numscalar("C2_sick0", C2_sick0)
//st_numscalar("H2_sick0", H2_sick0)
st_matrix("C2_sick0", C2_sick0)
st_matrix("H2_sick0", H2_sick0)
st_matrix("ones", ones)

MU_H  = (1+$PHI_1_TILDE) :* $PHI_2_TILDE :* (C2_sick0:^(1+1/$EPS) + $PHI_2_TILDE:*(H2_sick0:^(1+1/$EPS))):^((1-$GAMMA)/(1+1/$EPS)-1) :* H2_sick0:^(1/$EPS)
MU_C2 = (1+$PHI_1_TILDE) :* ((C2_sick0:^(1+1/$EPS) + $PHI_2_TILDE:*(H2_sick0:^(1+1/$EPS))):^((1-$GAMMA)/(1+1/$EPS)-1)) :* (C2_sick0 :^(1/$EPS))
MU_C2h = C2_healthy0:^(-$GAMMA)

MU_H = (MU_H' * ones) / rows(C2_sick0)
MU_C2 = (MU_C2' * ones) / rows(C2_sick0)
MU_C2h = (MU_C2h' * ones) / rows(C2_healthy0)
MU_C1 = c1^(-$GAMMA)

st_numscalar("MU_H", MU_H)
st_numscalar("MU_C2h", MU_C2h)
st_numscalar("MU_C2", MU_C2)
st_numscalar("MU_C1", MU_C1)

Hbar = (H2_sick0' * ones) / rows(H2_sick0)
st_numscalar("Hbar", Hbar)

MU_H
MU_C2

ones = 111111
ones
$GAMMA
$EPS

if ($GAMMA != 1) {
 U2_healthy = (1/(1-$GAMMA)) :* (W :^ (1-$GAMMA))
 U2_sick    = $PHI_0 :+ ///
      (1/(1-$GAMMA)) :* (1+$PHI_1_TILDE) :* ((C2_sick0 :^ (1+1/$EPS)) :+ ($PHI_2_TILDE) :* ((H2_sick0) :^ (1+1/$EPS)) ) :^ ((1-$GAMMA)/(1+1/$EPS))
}
else {
  U2_healthy = log(W)
  U2_sick    = $PHI_0 :+ ///
      (1+$PHI_1_TILDE) :* log( ((C2_sick0 :^ (1+1/$EPS)) :+ ($PHI_2_TILDE) :* ((H2_sick0) :^ (1+1/$EPS)) ) :^ (1/(1+1/$EPS)) )
}


ones = J(rows(U2_healthy), 1, 1)
E_U2 =    $p  * (U2_healthy'  * ones) / rows(U2_healthy) + ///
       (1-$p) * (U2_sick' * ones) / rows(U2_sick)
st_numscalar("E_U2", E_U2)

U2_sick_avg = (U2_sick' * ones) / rows(U2_sick)
st_numscalar("U2_sick", U2_sick_avg)


if ($CALC_DIFF == 0) {
 st_numscalar("diff", 0)

}
else {
/**
 *******************
 *******************
PHI_1 = $CALC_DIFF
PHI_1_TILDE = ///
  (1 + PHI_1)^((1+1/$EPS)/(1-$GAMMA))  /    ///
  (1 + $m*(1-($b)))^((1-$GAMMA)/(1+1/$EPS) - 1)   ///
  - 1


C2_sick = W :/ (1 + ((1-($b))^(1+$EPS))*(($PHI_2_TILDE)^(-1*$EPS)))
H2_sick  = (W :- C2_sick) :/ (1-($b))

 U2_healthy = (1/(1-$GAMMA)) :* (W :^ (1-$GAMMA))
 U2_sick    = $PHI_0 :+ ///
      (1/(1-$GAMMA)) :* (1+PHI_1_TILDE) :* ((C2_sick :^ (1+1/$EPS)) :+ ($PHI_2_TILDE) :* ((H2_sick) :^ (1+1/$EPS)) ) :^ ((1-$GAMMA)/(1+1/$EPS))

ones = J(rows(U2_healthy), 1, 1)
E_U2_temp =    $p  * (U2_healthy' * ones) / rows(U2_healthy) + ///
            (1-$p) * (U2_sick'    * ones) / rows(U2_sick)
E_U2_temp

diff = E_U2 - E_U2_temp  
diff
st_numscalar("diff", diff)
st_numscalar("E_U2_temp", E_U2_temp)
st_numscalar("phi1_test", PHI_1_TILDE)

PHI_2 = (1+$PHI_1_TILDE) * $PHI_2_TILDE * (C2_sick^(1+1/$EPS) + $PHI_2_TILDE*(H2_sick^(1+1/$EPS)))^((1-$GAMMA)/(1+1/$EPS)-1)
st_numscalar("PHI_2", PHI_2)
 *******************
 *******************
 **/
}


end

exit


