
/**
 **

Code to create APPENDIX data tables for 
  "What good is wealth without health?"

NOTES: 

- This code will only run on UNIX/Linux!  It will not run on windows
because it saves temporary files to /tmp/.

- The following three files will re-generate analysis file from the
raw HRS data (not included).

 do rand
 do prepareSample
 do make_rand_hrs_final noi

 **
 **/



clear
set more off
set mem 1800m

set linesize 130

set seed 12345

set type double, permanently

**
** Make data set from "raw" data sets (RAND HRS, raw HRS, etc.)
**
**do rand
**do prepareSample
**do make_rand_hrs_final noi
**
**

*est clear
*drop _all
*use rand_hrs_final.dta

**
* This code helps for bootstrapped standard errors
**
local bsample = 0
global OUTPUT_DIRECTORY = "./outputAppendix/"
*save /tmp/bsample_`bsample'.dta, replace


**
* Table A1 and A2 - appendix talbes withsummary statistics
**
*do tableA1_summ_stats `bsample' "A1"
*do tableA1_summ_stats `bsample' "A2"


**
* Table A3 - alternative specifications
*   no x's, spousal health, habituation
*
*   NOTE: need to add in always single
*
**
*do tableA3_robustness.do `bsample' 0  0
*do tableA3_robustness.do `bsample' 15 0


**
* Table A4 - individual disease results
**
*do tableA4_ind_dis.do `bsample'

**
* Table A5 - symptomatic/asymptomatic
**
*do tableA5_asympto.do `bsample'

**
* Table A6 - does effect vary by num diseases?
**
*do tableA6_hetero_effects.do `bsample'

**
* Table A7 - alternative measures of key variables
**
*do tableA7_alternatives `bsample' 0 0 rwhappy
*do tableA7_alternatives `bsample' 0 0 rcesd
*do tableA7_alternatives `bsample' 0 0 rcesd4

** NOTE: This is table A7
*do tableA7_alternatives `bsample' 15 0 rwhappy
*do tableA7_alternatives `bsample' 15 0 rcesd
*do tableA7_alternatives `bsample' 15 0 rcesd4

**
* Table A9 - consumption trends
**
*do tableA9_cons_trend `bsample' 0
*do tableA9_cons_trend `bsample' 1

**
* Table A10 - interactions
**
*do tableA10_inters `bsample' 0  0
*do tableA10_inters `bsample' 15 0

**
* Table A11 - severity
**
*do tableA11_severity `bsample' 

exit


**
* Table B* - more interactions
**
forvalues i = 1/2 {
 do tableA10_inters `bsample' 0  `i'
 do tableA10_inters `bsample' 15 `i'
}

**
* Table B* - more alternative measures of key variables
**
forvalues i = 1/2 {
 do tableA7_alternatives `bsample' 0 `i' rwhappy
 do tableA7_alternatives `bsample' 0 `i' rcesd
 do tableA7_alternatives `bsample' 0 `i' rcesd4
}

forvalues i = 1/2 {
 do tableA7_alternatives `bsample' 15 `i' rwhappy
 do tableA7_alternatives `bsample' 15 `i' rcesd
 do tableA7_alternatives `bsample' 15 `i' rcesd4
}

exit












do tableZ_jeea `bsample'

do tableZ_jeea2 `bsample'

do tableZ_catchall.do `bsample' 0

do tableZ_catchall.do `bsample' 15

/**
do tableZ_fixed_alpha `bsample'
do tableZ_fixed_alpha `bsample' 2 
do tableZ_fixed_alpha `bsample' 3
do tableZ_fixed_alpha `bsample' 4
do tableZ_fixed_alpha `bsample' 5
 **/

*do table10_hh_frac `bsample' 0 
*do table10_hh_frac `bsample' 1
