
set more off


**
* do table12_subsample `bsample' `sample'
***

capture program drop post_param
program define post_param, eclass
 ereturn scalar `1' = `2'
end

est clear
drop _all
use /tmp/bsample_`1'.dta

**
* NOTE: Konrad says you need to create separate panel ID variable each time HHIDPN is resampled
**
summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev

local var = "rnumdis"
local sample = `2'


 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_inc_perm {
  qui summ `xvar' if sample1 == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))


 capture drop *health_it
 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store `var'_`util'_`s'


** xthtaylor2 `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample0 == 1,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it log_inc_perm )
** kaboom
*ivreg fe (isblack isfemale log_inc_perm = _Iwave* isfemale isblack) , cluster(hhidpn)
* ivreg fe (log_inc_perm isblack isfemale = _Iwave*) if myn == 1, cluster(hhidpn)
* ivreg fe log_inc_perm if myn == 1, cluster(hhidpn)
* ivreg fe log_inc_perm isblack isfemale if myn == 1, cluster(hhidpn)

 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

 /**
  http://www.statalist.eu/statalist/archive/2004-02/msg00312.html

 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample`s' == 1 ,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage rageSquared single hh_size log_inc_perm )  

 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample`s' == 1 ,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage rageSquared single hh_size log_inc_perm isblack )  

 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample`s' == 1 ,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage rageSquared single hh_size log_inc_perm isfemale )  

 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample`s' == 1 ,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage single _Iwave* log_inc_perm  )  

 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample`s' == 1 ,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage single hh_size log_inc_perm isfemale )  

 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample`s' == 1 ,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage single hh_size log_inc_perm isblack )  

 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample`s' == 1 ,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage single hh_size isblack isfemale )  

 **/

 /**
  **
 xthtaylor `util'  ybar_iXhealth_it health_it log_inc_perm isblack isfemale rage rageSquared single hh_size _Iwave* if sample0 == 1,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it rage rageSquared single hh_size log_inc_perm )
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 global mu_`var'_`util'_`s' =  _b[log_inc_perm]
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 return list
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = 0
 global MU_inc_se = 0
 rand_areg
 est store `var'_`util'_`s'
 **
 **/


** 
* estout rnumdis_rwhappy_0 rnumdis_rwhappy_9 rnumdis_rwhappy_10 rnumdis_rwhappy_1 rnumdis_rwhappy_2 rnumdis_rwhappy_8 
**

capture estimates drop *fe*
estout rnumdis_rwhappy*  ///
 using ${OUTPUT_DIRECTORY}/table11_sample`2'.txt, keep(ybar_iXhealth_it health_it) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se  , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit
