
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

**
* NOTE: Konrad says you need to create separate panel ID variable each time HHIDPN is resampled
**
summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


if ("${OUTPUT_DIRECTORY}" == "") {
 di "=============="
 di " WARNING: setting output directory to /proj/matt/stateDependentUtility/rand/output/base"
 di "=============="
} 

** set in loop below
* local var = "rnumdis"

local sample = 0
local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev

local var = "rnumdis"


**
** rnumdis_rwhappy_9   (50%)
** rnumdis_rwhappy_10  (75%)
** rnumdis_rwhappy_11  (90%)
** rnumdis_rwhappy_8 - drop homemakers
**  (rnumdis_rwhappy_7 rnumdis_rwhappy_13 rnumdis_rwhappy_12)
**
** - estout rnumdis_rwhappy_0 rnumdis_rwhappy_9 rnumdis_rwhappy_10 rnumdis_rwhappy_1 rnumdis_rwhappy_2 rnumdis_rwhappy_8 

foreach sample of numlist 0 9 10 1 2 8 {

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

** END for each sample
}

estout rnumdis_rwhappy_0 rnumdis_rwhappy_9 rnumdis_rwhappy_10 rnumdis_rwhappy_1 rnumdis_rwhappy_2 rnumdis_rwhappy_8 ///
   using ${OUTPUT_DIRECTORY}/table13_alt_samps.txt, drop( _I* *age* *dummy* single hh_size *cons* ) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se  onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit
