set more off


/**
 REGRESSION OF CESD INDEX ON LOG PERMANENT INCOME (WITHOUT CONTROLS)
 **/

foreach util of varlist rcesd rcesd4 rwhappy rfracPrev rseatBelts rfracPrevExt r_sh {
**foreach util of varlist  rwhappy rcesd4 rcesd {
  **forvalues sample = 0(1)$max_sample {
  local sample = 0

    di "=========="
    di " calculate MU of income util: `util', sample: `sample'"
    di "=========="

    reg `util' log_inc_perm rnumdis dummy_inc_perm _Iwave* if sample`sample' == 1, cluster(hhidpn)
    est store `util'_`sample'

    reg `util' log_inc_perm rnumdis dummy_inc_perm isfemale isblack rage rageSquared single hh_size  _Iwave* if sample`sample' == 1, cluster(hhidpn)
    global mu_rnumdis_`util'_`sample'  = _b[log_inc_perm]
    est store `util'_`sample'c

    reg `util' log_inc_perm rnumdis dummy_inc_perm log_inc_curr dummy_inc_curr isfemale isblack rage rageSquared single hh_size  _Iwave* if sample`sample' == 1, cluster(hhidpn)
    est store `util'_`sample'c2

    reg `util' raedyrs rnumdis isfemale isblack rage rageSquared single hh_size _Iwave* if sample`sample' == 1, cluster(hhidpn)
    est store `util'_`sample'c3



 ** end for each sample
 ** }


}

estout  rwhappy_0 rwhappy_0c* ///
 using /bbkinghome/noto/stateDependentUtility/rand/table2.txt, drop(_I* *cons* *dummy*) ///
 stats(r2 N, fmt(%9.3f %9.0g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

estout  rcesd4_0 rcesd4_0c* rcesd_0 rcesd_0c* ///
 using /bbkinghome/noto/stateDependentUtility/rand/tableA2.txt, drop(_I* *cons* *dummy*) ///
 stats(r2 N, fmt(%9.3f %9.0g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 


/**
estout rfracPrev_0 rseatBelts_0 rfracPrevExt_0 r_sh_0 rwhappy_0_hnumdis rwhappy_0_radl_tot rwhappy_0_riadl_tot rwhappy_0_rofl_tot rwhappy_0_r_sh  rwhappy_2 rwhappy_3 rwhappy_4 rwhappy_5 rwhappy_6 rwhappy_7 ///
 using /bbkinghome/noto/stateDependentUtility/rand/tableA.txt, drop(_I* *cons*) ///
 stats(r2 N, fmt(%9.3f %9.0g)) modelwidth(22) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

estout rcesd_0_hnumdis rcesd_0_radl_tot rcesd_0_riadl_tot rcesd_0_rofl_tot rcesd_0_r_sh  rcesd_2 rcesd_3 rcesd_4 rcesd_5 rcesd_6 rcesd_7 ///
 using /bbkinghome/noto/stateDependentUtility/rand/tableA_2.txt, drop(_I* *cons*) ///
 stats(r2 N, fmt(%9.3f %9.0g)) modelwidth(22) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
**/
/**
 NOT NEEDED ANYMORE!!
    if ( ("`util'" == "rcesd" | "`util'" == "rwhappy" | "`util'" == "rcesd4") & `sample' <= 1) { 

     reg `util' log_inc_perm dummy_inc_perm isfemale isblack rage rageSquared single hh_size rhibpe rdi* rcanc* rlung* rhear* rstro* rpsy* rarthr* _Iw* if sample`sample' == 1, cluster(hhidpn)
     global mu_numdis_`util'_`sample'c = _b[log_inc_perm]
     est store `util'_`sample'c

     reg `util' log_inc_perm dummy_inc_perm isfemale isblack rage rageSquared single hh_size rnumdis _Iw* if sample`sample' == 1 & rnumdis == 0, cluster(hhidpn)
     global mu_numdis_`util'_`sample'c2 = _b[log_inc_perm]
     est store `util'_`sample'c2
     
     preserve
     drop log_inc_perm dummy_inc_perm
     rename log_inc_perm_p5 log_inc_perm
     rename dummy_inc_perm_p5 dummy_inc_perm
     reg `util' log_inc_perm dummy_inc_perm isfemale isblack rage rageSquared single hh_size rnumdis _Iw* if sample`sample' == 1, cluster(hhidpn)
     global mu_numdis_`util'_`sample'_p5 = _b[log_inc_perm]
     est store `util'_`sample'p5
     restore
    }

    if (("`util'" == "rcesd" | "`util'" == "rwhappy" | "`util'" == "rcesd4") & `sample' <= 1) { 
      foreach var of varlist hnumdis radl_tot riadl_tot rofl_tot r_sh  {
       gen h_it = `var'
       reg `util' log_inc_perm dummy_inc_perm isfemale isblack rage rageSquared single hh_size h_it _Iwave* if sample`sample' == 1 , cluster(hhidpn)
       global mu_`var'_`util'_`sample' = _b[log_inc_perm]
       est store `util'_`sample'_`var'
       capture drop h_it
      }
    }
**/
