
version 9.1

set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


** sample4  = alwaysSingle & sample0
** sample17 = alwaysSingle & sample15
if ("`2'" != "") {
 replace sample0 = sample`2'
}

 local var = "rnumdis"
 local util = "rwhappy"
 local sample = 0

 global reg = "areg"
 global options = " absorb(hhidpn) cluster(hhidpn) "

 di ""
 di " =============== " 
 di "doing var `var' `util' `sample' ..."
 di ${mu_`var'_`util'_`sample'}
 di " =============== " 
 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)

 *replace log_inc_perm = raedyrs

 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'


 **
 * graph code
 ** 
/**
 **
Can we estimate our plot (as in figure 1) non-parametrically?
E.g. divide the population in permanent income quintiles, plot the
average happiness of those with less than the median number of
diseases in each quintile.  Then calculate the average drop in
happiness of going from below to above median number of diseases by
quintile, subtract this from the first plot to find the happiness
curve for those with an above median number of diseases.  (we might
use income thirds, quartiles, or deciles, depending on how noisy the
resulting plot it is)
 local q = `2'
 xtile pct = log_inc_perm, nq(`q')
 tab pct, missing
 gen hi = (rnumdis >= `3')
 bys pct: egen avg_happy_temp = mean(rwhappy) if hi == 0
 bys pct: egen avg_happy = max(avg_happy_temp)

 sort hhidpn wave
 by hhidpn: gen prev_happy = rwhappy[_n - 1]
 by hhidpn: gen sum_hi = sum(hi)
 assert(sum_hi >= 0)
 tab sum_hi, missing
 keep if sum_hi == 1

 ** bys hhidpn: keep if _n == 1
 ** gen happy_drop = avg_hi - avg_lo
 gen happy_drop = rwhappy - prev_happy

 collapse (mean) happy_drop prev_happy (max) avg_happy, by (pct)
 ** replace avg_happy = prev_happy 
 replace happy_drop = avg_happy + happy_drop
 replace pct = (100 / `q') * (pct - 0.5)
 sort pct
 list

 twoway (scatter avg_happy  pct, sort  msymbol(0) ) ///
        (scatter happy_drop pct, sort  msymbol(T) ), ///
       title("Figure X: Drop in happiness by bucket") ///
       scheme(s2mono) ylabel(, nogrid) graphregion(fcolor(white)) ///
       legend(region(style(none))) ///
       legend(cols(1)) legend(label(1 "< `3' diseases")) ///
       legend(label(2 ">= `3' diseases")) ///
       xtitle("Percentile of income distribution") xlabel(0(10)100) ///
       ytitle("HAPPY")
 graph export figure_ge`3'_q`q'.eps, replace
 
 exit
 **
 **/ 



 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

/**

 (move this to other table!!)

  $reg `util' ybar_iXhealth_it health_it dummyY_iXhealth_it  _Iwave* if sample`sample' == 1 , $options
  est store   `var'_`util'_`sample'_noxs
  do calcMUincFE `var' `util' `sample' 0
  est restore `var'_`util'_`sample'_noxs
  loneway health_it hhidpn if e(sample) == 1
  local sd = r(sd_w)
  lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
  global one_b_over_muinc = r(estimate)
  global one_b_se = r(se)
  lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
  global onesd_b_over_muinc = r(estimate)
  global onesd_b_se = r(se)
  global within_se = `sd'
  global MU_inc = ${mu_`var'_`util'_`sample'}
  global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
  rand_areg
  est store `var'_`util'_`sample'_noxs
**/


estout rnumdis_rwhappy_0 ///
 using ${OUTPUT_DIRECTORY}/table4_baseline`2'.txt, keep(ybar_iXhealth_it health_it) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
