

set more off


capture program drop add_parm
program add_parm, eclass
  ereturn scalar `1' = `2'
end


est clear
drop _all
use /tmp/bsample_0.dta


keep if sample0 == 1


summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



local var = "rnumdis"
local util = "rwhappy"
local s = 0

assert(sample0 == 1)

foreach xvar of varlist log_inc_perm rage rageSquared single hh_size _Iwa* {
  qui summ `xvar' if sample0 == 1
  qui replace `xvar' = `xvar' - r(mean)
}

capture drop *health_it
replace inc_perm = inc_perm / 10000
replace log_inc_perm = log(inc_perm)

summ log_inc_perm
replace log_inc_perm = log_inc_perm - r(mean)
gen double ybar_iXhealth_it   = rnumdis * log_inc_perm
gen health_it = rnumdis

gen cons = 1
local varlist = "ybar_iXhealth_it health_it rage rageSquared single hh_size _Iw* cons"
global varlist = "`varlist'"
local depvar = "rwhappy"
local id = "hhidpn"
foreach v of varlist `varlist' {
 keep if `v' < .
}



bys `id': egen sum_`depvar' = sum(`depvar')
bys `id': gen m`depvar'N = _N
summ rwhappy
local mean_happy = r(mean)
drop if sum_`depvar' == m`depvar'N | sum_`depvar' == 0

**
** after dropping all 0's and all 1's
**
xtset, clear
xtset hhidpn year

xtreg rwhappy `varlist', fe cluster(hhidpn)
predict fe, u

 est store no_0s_and_1s
 do calcMUincFEprobit `var' `util' `s' 1
 est restore no_0s_and_1s
 loneway health_it hhidpn if sample`s' == 1 & `var' < . & `util' < .
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store no_0s_and_1s


** re-number after dropped ...
rename `id' `id'_temp
egen `id' = group(`id'_temp)

replace fe = fe / normalden(0)

summ fe
replace fe = fe - r(mean)

**replace fe = 0


sum `id'
local max_N = r(max)

local NEWTON = 2
local j = 1
forvalues iter = 1/100 {
 di " j: `j' ...
 if (`j' > 1) {
   matrix prev = eb
 }

 /** 
  No wave FEs here to match baseline ...
  **/
 capture drop fe_mfx
 gen fe_mfx = fe
 reg fe_mfx log_inc_perm isfemale isblack rage rageSquared single hh_size, cluster(hhidpn)
 global beta4 = _b[log_inc_perm]
 global beta4_se = _se[log_inc_perm]

 **replace fe_mfx = fe * normden(0)
 **replace fe_mfx = fe * normalden(0)
 **reg fe_mfx log_inc_perm isfemale isblack rage rageSquared single hh_size, cluster(hhidpn)

 probit `depvar' $varlist, nocons offset(fe) iterate(5) cluster(hhidpn)
 matrix eb = e(b)
 if (`j' > 1) {
  if (abs(eb[1,1] - prev[1,1]) < 1e-7) {
   continue, break
  }
  if (abs(eb[1,1] - prev[1,1]) < 1e-4) {
   local NEWTON = 5
  }
 }
 qui do fe_probit_calc_fes `NEWTON'
 
 local j = `j' + 1
}





**
*fix standard errors
**
preserve

* first, check that you can duplicate
capture drop xb
predict xb, xb
di "generating H ..."
capture drop score
predict score, score
**gen double H = (normden(xb)*xb*normal(xb) - normden(xb)*normden(xb)) / (normal(xb)*normal(xb))
capture drop H
gen double H = -score * (score + xb)

matrix new_betas = e(b)
matrix newV = e(V)
matrix list newV
	
local row = 1
foreach row_var of varlist `varlist' {
 local col = 1
 foreach col_var of varlist `varlist' {
   **di "doing `row_var', `col_var' ..."
   egen double H_`row'_`col' = sum(H * `row_var' * `col_var')
   matrix newV[`row', `col'] = H_`row'_`col'[1]
   local col = `col' + 1
 }
 local row = `row' + 1
}

**capture drop H*_temp
**summ H*
**matrix list newV
matrix testV = -1 *inv(newV)

di "confirm we can re-generate same var-cov matrix ..."
matrix list testV

capture drop myn
bys hhidpn: gen myn = _n
bys hhidpn: egen H_sum = sum(H)

local row = 1
foreach row_var of varlist `varlist' {
  **egen double H_`row'_temp = sum(H * `row_var')
  bys hhidpn: egen H_`row' = sum(H * `row_var')
  **replace H_`row' = H_`row' / (sqrt(H_sum))
  replace H_`row' = 0 if myn != 1
  local row = `row' + 1
}

matrix updateV = newV

local row = 1
foreach row_var of varlist `varlist' {
 local col = 1
 foreach col_var of varlist `varlist' {
   capture drop temp_v
   egen temp_v = sum(H_`row' * H_`col' / H_sum)
	   matrix updateV[`row', `col'] = temp_v[1]
   local col = `col' + 1
 }
 local row = `row' + 1
}
matrix finalV = -1 * (inv( newV - updateV))
matrix list finalV

restore

*global test1 = e[1,1] / eb[1,1]
*global test2 = e[1,2] / eb[1,2]
*di "test1: $test1, test2: $test2"

mfx, varlist(ybar_iXhealth_it health_it)
matrix e =  e(Xmfx_dydx)

local onesd_b_over_muinc = eb[1,1] / $beta4 * `sd'

global beta1_se = sqrt(finalV[1,1]) *  e[1,1] / eb[1,1]
global beta1_p  = 2*ttail(3255, abs(e[1,1]/$beta1_se))
add_parm "beta1" e[1,1]
add_parm "beta1_se" $beta1_se
add_parm "beta1_p" $beta1_p

global beta2_se = sqrt(finalV[2,2]) *  e[1,1] / eb[1,1]
global beta2_p  = 2*ttail(3255, abs(e[1,2]/$beta2_se))
add_parm "beta2" e[1,2]
add_parm "beta2_se" $beta2_se
add_parm "beta2_p" $beta2_p

global beta4 = $beta4 * e[1,1] / eb[1,1]
global beta4_se = $beta4_se * e[1,1] / eb[1,1]
add_parm "beta4" $beta4
add_parm "beta4_se" $beta4_se

add_parm "onesd_b_over_muinc" `onesd_b_over_muinc'
est store x

est drop *0fe0*
estout * ///
 using ${OUTPUT_DIRECTORY}/table5_fe_probit.txt, drop(_Iw* *cons* rage rageSquared single hh_size) ///
 stats(N r2 MU_inc MU_inc_se converged onesd_b_over_muinc onesd_b_se beta1 beta1_se beta1_p beta2 beta2_se beta2_p beta4 beta4_se, fmt(%9.0f %9.5f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit

