
capture log close
log using ${OUTPUT_DIRECTORY}/table5_nlls_xalpha.txt, replace text

  
**
* To run ... 
*   either use "do bs1 ..."
*   or "do nlls_xalpha 0 2"


global varlist = "ybar_iXhealth_it health_it rage rageSquared single hh_size _Iw*"
**global varlist = "ybar_iXhealth_it health_it"
global depvar = "rwhappy"
global id = "hhidpn"
local id = "$id"



capture program drop add_parm
program add_parm, eclass
  ereturn scalar `1' = `2'
end


**
* note: "xb" required
**
capture program drop nlcalc_xb

program nlcalc_xb
  version 8.0
  if ("`1'" == "?") {
    global S_1 = "B1 B2 B3 B4 B5 B6 B7 B8 B9 B10 B11 B12 B13 gamma"
    forvalues b = 1(1)13 {
     global B`b' = ${B`b'init}
    }
    global gamma = 0
    exit
  }

  capture drop xb_temp
  gen xb_temp = 0
  local b = 1
  foreach var of varlist $varlist {
   replace xb_temp = xb_temp + ${B`b'} * `var'
   local b = `b' + 1
  }

  replace `1' = xb_temp + fe
end



est clear
drop _all
matrix drop _all
use /tmp/bsample_`1'.dta


keep if sample0 == 1


*summ hhidpn
*local max_hhidpn = r(max)
*sort hhidpn wave
*by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 

keep if rnumdis < .

**gen rand = uniform()
**bys `id': replace rand = rand[1]
**keep if rand < 0.15

xi i.wave
gen cons = 1

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 

local var = "rnumdis"
local util = "rwhappy"
local s = 0


foreach xvar of varlist log_inc_perm rage rageSquared single hh_size _Iwa* {
  qui summ `xvar' if sample0 == 1
  qui replace `xvar' = `xvar' - r(mean)
}


gen double inc_perm_copy = inc_perm / 1000
drop inc_perm
gen double inc_perm = inc_perm_copy
drop inc_perm_copy


global alpha = `2'
if ($alpha != 1) {
  capture drop log_inc_perm
  gen double log_inc_perm = inc_perm^(1-$alpha) / (1-$alpha)
}

capture drop *health_it
summ log_inc_perm
replace log_inc_perm = log_inc_perm - r(mean)
gen double ybar_iXhealth_it   = rnumdis * log_inc_perm
gen health_it = rnumdis

**keep $depvar $varlist $id wave log_inc_perm isfemale isblack





sort `id' rwhappy
capture drop myn
by `id': gen myn = _n



 xtset, clear
 xtset hhidpn year
xtreg $depvar $varlist, fe cluster(hhidpn)
predict d, u
predict xb, xb
gen double fe = d + _b[_cons]
summ fe, det
summ xb, det
drop xb


/**
capture nl (fe = ({b1}*(( (inc_perm)^(1-{b2}))/(1-{b2})) + {b4}*rage + {b5}*rageSquared + {b6}*single + {b7}*hh_size + {b8}*isfemale + {b9}*isblack + {b10}*cons ) ), initial(b1 $MU_inc b2 $alpha b4 0 b5 0 b6 0 b7 0 b8 0 b9 0 b10 0)  cluster(hhidpn) iterate(50) eps(1e-5)
 matrix fe = e(b)
 global MU_inc = fe[1,1]
 global alpha = fe[1,2]
 **/
 

if ($alpha != 1) {
  capture drop log_inc_perm
  gen double log_inc_perm = inc_perm^(1-$alpha) / (1-$alpha)
}


loneway health_it `id'
global sd = r(sd_w)

global converged = 0

forvalues iter = 1(1)100 {

 di "=========="
 di "init alpha: `2', ITERATION: `iter' ..."
 di "=========="

replace log_inc_perm = inc_perm^(1-$alpha) / (1-$alpha)
summ log_inc_perm 
replace log_inc_perm = log_inc_perm - r(mean)
replace ybar_iXhealth_it = log_inc_perm * rnumdis

/**
 **
sort `id'
foreach xvar of varlist $varlist {
  capture drop mean_`xvar'
  by `id': egen mean_`xvar' = mean(`xvar')
  qui replace `xvar' = `xvar' - mean_`xvar'
}
capture nl (rwhappy = {b1}*ybar_iXhealth_it + {b3}*health_it + {xb: rage rageSquared single hh_size _Iw*} ), init(b1 0 b3 -0.1) eps(1e-5)
matrix nl = e(b)
global beta1 = nl[1,1]
global beta3 = nl[1,2]

foreach xvar of varlist $varlist {
  qui replace `xvar' = `xvar' + mean_`xvar'
}
capture drop yhat
predict yhat, yhat

capture drop fe_raw
capture drop fe_old
gen fe_raw = rwhappy - yhat
gen fe_old = fe
capture drop fe
bys hhidpn: egen fe = mean(fe_raw)
summ fe
replace fe = fe - r(mean)
 **
 **/

capture drop fe_old
gen fe_old = fe

areg rwhappy $varlist, absorb(hhidpn)
global beta1 = _b[ybar_iXhealth_it]
global beta3 = _b[health_it]
capture drop d
capture drop fe
predict d, d
gen fe = d + _b[_cons]


reg fe log_inc_perm rage rageSquared single hh_size isfemale isblack
global MU_inc = _b[log_inc_perm]
nl (fe = ({b1}*(( (inc_perm)^(1-{b2}))/(1-{b2})) + {b4}*rage + {b5}*rageSquared + {b6}*single + {b7}*hh_size + {b8}*isfemale + {b9}*isblack + {b10}*cons ) ), initial(b1 $MU_inc b2 $alpha b4 0 b5 0 b6 0 b7 0 b8 0 b9 0 b10 0)  cluster(hhidpn) iterate(50) eps(1e-5)
 matrix fe = e(b)
 **matrix list fe
 global MU_inc = fe[1,1]
 global alpha = fe[1,2]

**di "$alpha , $sd , $MU_inc, $beta1, $beta3"
global sigma_b1_over_b4 = $sd * $beta1 / $MU_inc

matrix results = [nullmat(results) \ $beta1, $alpha, $beta3, $MU_inc, $sigma_b1_over_b4]
matrix list results

matrix final =  [$beta1, $alpha, $beta3, $MU_inc, $sigma_b1_over_b4]
matrix rownames final = final

local rows = rowsof(results)
local cols = colsof(results)

if (`iter' > 4) {
 if (abs(results[`rows', `cols'] - results[`rows' - 1, `cols']) < 5e-6) {
  global converged = 1
  continue, break
 }
}

** end for
}

matrix final = [final, $converged]
matrix list final

capture log close

exit
