
set more off

capture program drop post_param
program define post_param, eclass
 ereturn scalar `1' = `2'
end

est clear
drop _all
use /tmp/bsample_`1'.dta

**
* NOTE: Konrad says you need to create separate panel ID variable each time HHIDPN is resampled
**
preserve
keep if sample0 == 1
bys hhidpn: keep if _n == 1
count
restore

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 

preserve
keep if sample0 == 1
bys hhidpn: keep if _n == 1
count
restore

preserve
keep if sample0 == 1
sort hhidpn wave
by hhidpn: gen prev_h = rnumdis[_n-1]
keep if prev_h < .
count
restore






**
* get final sample
keep if rwhappy < . 
keep if log_inc_perm < .
keep if single < .
keep if rage < .
keep if isretired < .
keep if hh_size < .
keep if rnumdis < .


local sample = 0
local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev

local var = "rnumdis"
local sample = 0



 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

*******************
** ADAPTATION
*******************

     preserve

     ** NOTE: We are dropping BEFORE using previous ...
     keep if sample0 == 1

     capture drop *health_it
     gen h_it = rnumdis
     sort hhidpn wave
     by hhidpn: gen h_prev1 = h_it[_n-1]
     by hhidpn: gen h_prev2 = h_it[_n-2]
     by hhidpn: gen h_prev3 = h_it[_n-3]
     by hhidpn: gen h_post1 = h_it[_n+1]
     by hhidpn: gen h_post2 = h_it[_n+2]
     by hhidpn: gen h_post3 = h_it[_n+3]

     gen ybarXhit = log_inc_perm * h_it
     gen ybarXprev1 = log_inc_perm * h_prev1
     gen ybarXprev2 = log_inc_perm * h_prev2
     gen ybarXpost1 = log_inc_perm * h_post1
     gen ybarXpost2 = log_inc_perm * h_post2


/**
     $reg `util' ybarXhit h_it single hh_size rage rageSquared _Iw* if sample`sample' == 1 & h_prev1 < ., $options
     est store adapt_sample
     do calcMUincFE `var' `util' `sample' 0
     est restore adapt_sample
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adapt_sample

     $reg `util' ybarXhit h_it single hh_size rage rageSquared _Iw* if sample`sample' == 1 & h_prev1 < . & h_prev2 < ., $options
     est store adapt_sample2
     do calcMUincFE `var' `util' `sample' 0
     est restore adapt_sample2
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adapt_sample2

     $reg `util' h_it h_prev1 h_prev2 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adapt_base
     do calcMUincFE `var' `util' `sample' 0
     est restore adapt_base
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adapt_base

     $reg `util' h_it h_prev1 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adapt_1
     do calcMUincFE `var' `util' `sample' 0
     est restore adapt_1
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adapt_1

     $reg `util' h_it h_prev2 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adapt_2
     do calcMUincFE `var' `util' `sample' 0
     est restore adapt_2
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adapt_2

     $reg `util' h_it h_prev3 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adapt_3
     do calcMUincFE `var' `util' `sample' 0
     est restore adapt_3
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adapt_3

     $reg `util' h_post1 h_it h_prev1 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adapt_11
     do calcMUincFE `var' `util' `sample' 0
     est restore adapt_11
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adapt_11
**/

     $reg `util' ybarXhit ybarXprev1 h_it h_prev1 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adaptX_1
     do calcMUincFE `var' `util' `sample' 0
     est restore adaptX_1
     loneway rnumdis hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybarXhit] / ${mu_`var'_`util'_`s'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybarXhit] / ${mu_`var'_`util'_`s'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`s'}
     global MU_inc_se = ${mu_`var'_`util'_`s'_se}
     rand_areg
     est store adaptX_1

/**
 **
     $reg `util' ybarXhit ybarXprev2 h_it h_prev2 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adaptX_2
     do calcMUincFE `var' `util' `sample' 0
     est restore adaptX_2
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adaptX_2

     $reg `util' ybarXpost1 ybarXhit ybarXprev1 h_post1 h_it h_prev1 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adaptX_11
     do calcMUincFE `var' `util' `sample' 0
     est restore adaptX_11
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se
     post_param "ind_N" $ind_N
     est store adaptX_11
 **
 **/

     restore

estout adapt*   ///
 using ${OUTPUT_DIRECTORY}/table6_adaptation.txt, keep(ybar* h*it h_*)  ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se  , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit
