
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



**
* get final sample
keep if rwhappy < . 
keep if log_inc_perm < .
keep if single < .
keep if rage < .
keep if isretired < .
keep if hh_size < .
keep if rnumdis < .



** set in loop below
* local var = "rnumdis"

local sample = 0
local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev



** estout rnumdis_rwhappy_0 *l_tot_rwhappy_0 rh_idx_rwhappy_0 
** rnumdis_rwhappy_4 sp_rnumdis_rwhappy_0*

foreach var of varlist rnumdis radl_tot riadl_tot rofl_tot rh_idx r_sh r_sh_limwk {

 local util = "rwhappy"

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 ** these get rid of singletons(!)
 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'


 if ("`var'" == "rnumdis") {

  **local s = 4
  local util = "r_sh_u"

  $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
  est store   `var'_`util'_`s'
  do calcMUincFE `var' `util' `s' 1
  est restore `var'_`util'_`s'
  loneway health_it hhidpn if e(sample) == 1
  local sd = r(sd_w)
  lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
  global one_b_over_muinc = r(estimate)
  global one_b_se = r(se)
  lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
  global onesd_b_over_muinc = r(estimate)
  global onesd_b_se = r(se)
  global within_se = `sd'
  global MU_inc = ${mu_`var'_`util'_`s'}
  global MU_inc_se = ${mu_`var'_`util'_`s'_se}
  rand_areg
  est store `var'_`util'_`s'


 }


** END for each var (rnumdis, adl_tot, etc.)
}

est drop *fe*

**rnumdis_rwhappy_0 *l_tot_rwhappy_0 rh_idx_rwhappy_0 rnumDisWgt_rwhappy_0 sp_rnumdis_rwhappy_0* ///

estout * /// 
   using ${OUTPUT_DIRECTORY}/table6_alt_health.txt,  keep(ybar_iXhealth_it health_it ) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers )  


