
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


 local var = "rnumdis"
 local util = "rwhappy"
 local sample = 0
 
 global reg = "areg"
 global options = " absorb(hhidpn) cluster(hhidpn) "

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)

 summ log_inc_perm, det

 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 **
 **foreach a of numlist 100 500 600 700 800 900 1000 1100 1200 1300 1400 1500
 **

 foreach a of numlist 100 50 200 300 500 1000 {
 **foreach a of numlist 100 

  preserve
  di "############"
  di " alpha: `a'"
  di "############"

  local alpha = `a' / 100

  if (`alpha' != 1) { 
   summ log_inc_perm
   local sigma_x = r(sd)
   local mu_x = r(mean)
   rename log_inc_perm log_inc_perm_old
   gen double log_inc_perm = ( (inc_perm/1000) ^ (1 - `alpha')) / (1 - `alpha')
   drop log_inc_perm_old

   summ log_inc_perm
   **replace log_inc_perm = log_inc_perm * 1e25
   **replace log_inc_perm = log_inc_perm * (`sigma_x' / r(sd))
   summ log_inc_perm
  }
  else {
   ** don't replace log_inc_perm 
  }

  qui summ log_inc_perm if sample`sample' == 1
  qui replace log_inc_perm = log_inc_perm - r(mean)
  
  drop ybar_iXhealth_it
  gen double ybar_iXhealth_it = log_inc_perm * `var'

  $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , $options
  est store  alpha_`a'
  do calcMUincFE `var' `util' `sample' 1
  est restore  alpha_`a'
  loneway health_it hhidpn if e(sample) == 1
  local sd = r(sd_w)
  lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
  global one_b_over_muinc = r(estimate)
  global one_b_se = r(se)
  lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
  global onesd_b_over_muinc = r(estimate)
  global onesd_b_se = r(se)
  global within_se = `sd'
  global MU_inc = ${mu_`var'_`util'_`sample'}
  global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
  rand_areg
  est store alpha_`a'

  **
  * purely X-sectional
  **
  ** reg `util' log_inc_perm health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , cluster(hhidpn)
  ** reg `util' log_inc_perm health_it dummyY_iXhealth_it isfemale isblack rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , cluster(hhidpn)  
  **  xtreg `util' log_inc_perm health_it dummyY_iXhealth_it isfemale isblack rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , cluster(hhidpn) i(hhidpn)
  **  xthtaylor2 `util'  ybar_iXhealth_it health_it log_inc_perm isfemale isblack rage rageSquared single hh_size _Iwave* if sample0 == 1,  i(hhidpn) t(wave) endog( ybar_iXhealth_it health_it log_inc_perm rage rageSquared single  )

  restore

  ** end foreach alpha
  }

 estout alpha_*  ///
  using ${OUTPUT_DIRECTORY}/table7_nonlinear.txt, keep(health_it ybar_iXhealth_it) ///
  stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se, fmt(%9.3f)) modelwidth(15) ///
  cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
