
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


local y = "`4'"


 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

/**
rename rseatBelts rbelts
rename rfracPrevExt rprev

gen pca_happy = rwhappy
gen pca_enlife= renlife
gen pca_sad   = 1-rfsad
gen pca_lone  = 1-rflone
gen pca_going = 1-rgoing
gen pca_sleep = 1-rsleepr
gen pca_effort= 1-reffort
gen pca_depres= 1-rdepres

gen double pow_cesd_2 = (rcesd ^ 2)
gen double pow_cesd_half = (rcesd ^ 0.5)
gen double log_cesd = log(1 + rcesd)
gen double log_log_cesd = log(1 + log(1 + rcesd))
gen double exp_cesd = exp(rcesd)
gen double exp_exp_cesd = exp(exp(rcesd))
 **/

*local var = "rnumdis"
foreach var of varlist rnumdis radl_tot riadl_tot rofl_tot rh_idx {

local sample = `2'

** (set in loop below)
** local util = "rwhappy"


 ** rwhappy rcesd4 rcesd 
foreach util of varlist `y' {

 ** rfsad rbelts rprev pca_* pow_* log_cesd log_log_cesd exp_cesd exp_exp_cesd 

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 if (`3' == 0) {
  replace log_inc_perm = log(inc_perm / 1000)
 }
 if (`3' == 1) {
  replace log_inc_perm = raedyrs
 }
 if (`3' == 2) {
  replace log_inc_perm = log(wealth_perm)
 }

 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_inc_perm {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 ** these get rid of singletons(!)
 local s = `sample'
 if ("`util'" == "rbelts") {
   local s = 12
 }
 if ("`util'" == "rprev") {
   local s = 13
 }


 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

}


}

 est drop *fe0*

 estout * ///
   using ${OUTPUT_DIRECTORY}/table8_utils_`2'_`3'_`4'.txt, keep(ybar_iXhealth_it health_it ) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se, fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

 exit

 estout rnumdis_pca_* ///
   using ${OUTPUT_DIRECTORY}/tableZ_ind_utils.txt, keep(ybar_iXhealth_it health_it ) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se, fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

 estout  rnumdis_rwhappy_0  rnumdis_pow_* rnumdis_log* rnumdis_exp* ///
   using ${OUTPUT_DIRECTORY}/tableZ_nl_transforms.txt, keep(ybar_iXhealth_it health_it ) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se, fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

