
set more off

capture program drop add_param
program add_param, eclass
  ereturn scalar `1' = `2'
end

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 

local sample = 0

foreach xvar of varlist single rage rageSquared hh_size _Iw* log_inc_perm dummy_inc_perm {
 qui summ `xvar' if sample`sample' == 1
 qui replace `xvar' = `xvar' - r(mean)
}
capture drop ybarX*
gen ybarXrnumdis = log_inc_perm * rnumdis

reg rnumdis log_inc_perm dummy_inc_perm rage rageSquared single hh_size isfemale isblack [aw=wgt] if sample`sample' == 1, cluster(hhidpn)
summ rnumdis
add_param mu r(mean)
**add_param sigma r(sd)
loneway rnumdis hhidpn if e(sample) == 1
add_param sigma r(sd_w)
est store prob_`sample'

 reg lung_oxy log_inc_perm dummy_inc_perm rage rageSquared single hh_size isfemale isblack [aw=wgt] if sample`sample' == 1 & rlunge == 1, cluster(hhidpn)
summ lung_oxy
add_param mu r(mean)
**add_param sigma r(sd)
loneway lung_oxy hhidpn if e(sample) == 1
add_param sigma r(sd_w)
 est store lung_oxy

 reg diab_sev log_inc_perm dummy_inc_perm rage rageSquared single hh_size isfemale isblack [aw=wgt] if sample`sample' == 1 & rdiabe == 1, cluster(hhidpn)
summ diab_sev
add_param mu r(mean)
**add_param sigma r(sd)
loneway diab_sev hhidpn if e(sample) == 1
add_param sigma r(sd_w)
 est store diab
 reg diab_sev2 log_inc_perm dummy_inc_perm rage rageSquared single hh_size isfemale isblack [aw=wgt] if sample`sample' == 1 & rdiabe == 1, cluster(hhidpn)
summ diab_sev2
add_param mu r(mean)
**add_param sigma r(sd)
loneway diab_sev2 hhidpn if e(sample) == 1
add_param sigma r(sd_w)
 est store diab2

 reg stroke_sev log_inc_perm dummy_inc_perm rage rageSquared single hh_size isfemale isblack [aw=wgt] if sample`sample' == 1 & rstroke == 1, cluster(hhidpn)
summ stroke_sev
add_param mu r(mean)
**add_param sigma r(sd)
loneway stroke_sev hhidpn if e(sample) == 1
add_param sigma r(sd_w)
 est store stroke
 reg stroke_sev2 log_inc_perm dummy_inc_perm rage rageSquared single hh_size isfemale isblack [aw=wgt] if sample`sample' == 1 & rstroke == 1, cluster(hhidpn)
summ stroke_sev2
add_param mu r(mean)
**add_param sigma r(sd)
loneway stroke_sev2 hhidpn if e(sample) == 1
add_param sigma r(sd_w)
 est store stroke2

estout * ///
 using ${OUTPUT_DIRECTORY}/table9_severity.txt, keep(log_inc_perm) ///
 stats(r2 N mu sigma, fmt(%9.3f %9.0g %9.3g %9.3g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit
