
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



if ("${OUTPUT_DIRECTORY}" == "") {
 di "=============="
 di " WARNING: setting output directory to /proj/matt/stateDependentUtility/rand/output/base"
 di "=============="
} 

** set in loop below
* local var = "rnumdis"

local sample = 0
local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev


foreach var of varlist rnumdis {

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

     $reg `util' *health_it log_inc_curr dummy_inc_curr single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store curr_inc
     do calcMUincFE `var' `util' `sample' 0
     est restore curr_inc
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store curr_inc

     preserve
     replace ybar_iXhealth_it = raedyrs * health_it
     replace log_inc_perm = raedyrs 
     $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , $options
     est store edyrs
     do calcMUincFE `var' `util' `sample' 0
     est restore edyrs
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store edyrs
     restore


     preserve
     summ log_wealth_perm
     replace ybar_iXhealth_it = log(wealth_perm) * health_it
     replace log_inc_perm = log(wealth_perm)
     $reg `util'  ybar_iXhealth_it health_it rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , $options
     est store wealth
     do calcMUincFE `var' `util' `sample' 0
     est restore wealth
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store wealth
     restore


     preserve
     ** interact everything with income (!!) 
     gen double ybarXhh_size = log_inc_perm * hh_size
     gen double ybarXrage = log_inc_perm * rage
     gen double ybarXsingle = log_inc_perm * single
     $reg `util' *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store other_inters
     do calcMUincFE `var' `util' `sample' 0
     est restore other_inters
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store other_inters
     restore

** END for each var (rnumdis, adl_tot, etc.)
}


estout rnumdis_rwhappy_0 edyrs curr_inc wealth other_inters ///
   using ${OUTPUT_DIRECTORY}/table10_other.txt,  keep(ybar_iXhealth_it health_it log_inc_curr) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
