
set more off

capture program drop post_param
program define post_param, eclass
 ereturn scalar `1' = `2'
end



est clear
drop _all
use /tmp/bsample_`1'.dta

**
* NOTE: Konrad says you need to create separate panel ID variable each time HHIDPN is resampled
**
summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


local sample = 0
replace sample0 = sample`2'

keep if sample0 == 1



local util = "rwhappy"

 
 xtset, clear
 xtset hhidpn year
 global reg = "xtreg"
 global options = " fe cluster(hhidpn) "



*local var = "rnumdis"
foreach var of varlist rnumdis {


 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **

 if (`3' == 0) {
  replace log_inc_perm = log(inc_perm / 1000)
 }
 if (`3' == 1) {
  replace log_inc_perm = raedyrs
 }


 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_inc_perm {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store   `var'_`util'_`s'


*******************
** interactions
*******************

     preserve
     ** interact everything with income (!!) 
     gen double ybarXhh_size = log_inc_perm * hh_size
     gen double ybarXrage = log_inc_perm * rage
     gen double ybarXsingle = log_inc_perm * single
     $reg `util' *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store ints_`var'
     do calcMUincFE `var' `util' `sample' 0
     est restore ints_`var'
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store ints_`var'
     restore

     preserve
     ** interact everything with income (!!) 
     gen ybarXhh_size = log_inc_perm * hh_size
     gen ybarXrage = log_inc_perm * rage
     gen ybarXsingle = log_inc_perm * single
     $reg `util' *health_it ybarXhh_size ybarXsingle ybarXrage single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store ints2_`var'
     do calcMUincFE `var' `util' `sample' 0
     est restore ints2_`var'
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store ints2_`var'
     restore

}


est drop *fe0*

estout * ///
 using ${OUTPUT_DIRECTORY}/tableA10_inters_`2'_`3'.txt, drop( _* rage* hh_size single *dummy*) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit



