
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 




**
* get final sample
keep if rwhappy < . 
keep if log_inc_perm < .
keep if single < .
keep if rage < .
keep if isretired < .
keep if hh_size < .
keep if rnumdis < .

matrix table1 = J(38, 14, 0)


if ("`2'" == "A2") {
 ** alternative sample
 replace sample0 = sample15
}


keep if sample0 == 1


capture drop myn
capture drop numwaves
bys hhidpn: gen myn = _n
bys hhidpn: gen numwaves = _N


global summ_list = ///
 "numwaves inc_perm isfemale isblack single rage hh_size rnumdis snumdis radl_tot riadl_tot rofl_tot rh_idx rwhappy rcesd rcesd4"



local i = 1
foreach var of varlist $summ_list {

 di " - - - - - - "
 di "summarizing variables `var' ..."
 di " - - - - - - "

 local if_ind = ""
 **if ( "`var'" == "numwaves" | "`var'" == "inc_perm" | "`var'" == "isfemale" |  "`var'" == "isblack" ) {
 if ("`var'" == "kaboom") { 
  preserve 
  keep if `var' < . & sample0 == 1
  capture drop myn
  capture drop numwaves
  bys hhidpn: gen myn = _n
  bys hhidpn: gen numwaves = _N
  local if_ind = " & myn == 1 "
  summ `var' if myn == 1, det
  matrix table1[`i', 1] = r(N)
  matrix table1[`i', 2] = r(mean)
  matrix table1[`i', 3] = r(sd)
  matrix table1[`i', 4] = r(p5)
  matrix table1[`i', 5] = r(p50)
  matrix table1[`i', 6] = r(p95)
  restore

  preserve
  keep if `var' < . & sample1 == 1
  capture drop myn
  capture drop numwaves
  bys hhidpn: gen myn = _n
  bys hhidpn: gen numwaves = _N
  local if_ind = " & myn == 1 "
  summ `var' if sample1 == 1 `if_ind', det
  matrix table1[`i', 8] = r(N)
  matrix table1[`i', 9] = r(mean)
  matrix table1[`i', 10] = r(sd)
  matrix table1[`i', 11] = r(p5)
  matrix table1[`i', 12] = r(p50)
  matrix table1[`i', 13] = r(p95)
  restore

 }
 else {

  local s = 0
  if ("`var'" == "rseatBelts") {
   local s = 12
  }
  if ("`var'" == "rfracPrevExt") {
   local s = 13
  }

 summ `var' if sample`s' == 1 `if_ind', det
 matrix table1[`i', 1] = r(N)
 matrix table1[`i', 2] = r(mean)
 matrix table1[`i', 3] = r(sd)
 matrix table1[`i', 4] = r(p5)
 matrix table1[`i', 5] = r(p50)
 matrix table1[`i', 6] = r(p95)
 loneway `var' hhidpn if sample0 == 1
 matrix table1[`i', 7] = r(sd_w)

 summ `var' if sample1 == 1 `if_ind', det
 matrix table1[`i', 8] = r(N)
 matrix table1[`i', 9] = r(mean)
 matrix table1[`i', 10] = r(sd)
 matrix table1[`i', 11] = r(p5)
 matrix table1[`i', 12] = r(p50)
 matrix table1[`i', 13] = r(p95)
 loneway `var' hhidpn if sample1 == 1
 matrix table1[`i', 14] = r(sd_w)

 }
 local i = `i' + 1
}

preserve 

matrix list table1
drop _all
svmat table1
rename table11 N_0
rename table12 mean_0
rename table13 sd_0
rename table14 p5_0
rename table15 p50_0
rename table16 p95_0
rename table17 lway_0

rename table18 N_1
rename table19 mean_1
rename table110 sd_1
rename table111 p5_1
rename table112 p50_1
rename table113 p95_1
rename table114 lway_1

drop *_1
outsheet using ${OUTPUT_DIRECTORY}/table`2'_summ_stats.txt, replace

restore

tab rnumdis, missing



	

