
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 





** set in loop below
* local var = "rnumdis"

local sample = `2'
local util = "rwhappy"
 
 xtset, clear
 xtset hhidpn year
 global reg = "xtreg"
 global options = " fe cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev

foreach var of varlist rnumdis {

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **

 if (`3' == 0) {
  replace log_inc_perm = log(inc_perm / 1000)
 }
 if (`3' == 1) {
  replace log_inc_perm = raedyrs
 }
 if (`3' == 2) {
  replace log_inc_perm = log_wealth_perm
 }

 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_inc_perm {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'_noxs
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'_noxs
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'_noxs



    preserve

  di "beginning spouse ..."
  gen shealth_it = snumdis
  gen double ybar_iXshealth_it = log_inc_perm * snumdis
  gen dummyY_iXshealth_it = dummy_inc_perm * snumdis

 local sample = `s'

 $reg `util' ybar_iXhealth_it health_it ybar_iXshealth_it shealth_it rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , $options
 test ybar_iXhealth_it = ybar_iXshealth_it
 est store   sp_`var'_`util'_`sample'
 do calcMUincFE `var' `util' 0 0
 est restore sp_`var'_`util'_`sample'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`sample'}
 global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
 rand_areg
/**
 **
 lincom _b[ybar_iXshealth_it] / ${mu_`var'_`util'_`sample'}
 global one_bs_over_muinc = r(estimate)
 global one_bs_se = r(se)
 lincom `sd' * _b[ybar_iXshealth_it] / ${mu_`var'_`util'_`sample'}
 global onesd_bs_over_muinc = r(estimate)
 global onesd_bs_se = r(se)
 global sp_within_se = `sd'
 rand_spouse_areg
 **
 **/
 est store sp_`var'_`util'_`sample'

    restore


*******************
** ADAPTATION
*******************

     preserve

     ** NOTE: We are dropping BEFORE using previous ...
     keep if sample`sample' == 1

     capture drop *health_it
     gen h_it = rnumdis
     sort hhidpn wave
     by hhidpn: gen h_prev1 = h_it[_n-1]
     by hhidpn: gen h_prev2 = h_it[_n-2]
     by hhidpn: gen h_prev3 = h_it[_n-3]
     by hhidpn: gen h_post1 = h_it[_n+1]
     by hhidpn: gen h_post2 = h_it[_n+2]
     by hhidpn: gen h_post3 = h_it[_n+3]

     gen ybarXhit = log_inc_perm * h_it
     gen ybarXprev1 = log_inc_perm * h_prev1
     gen ybarXprev2 = log_inc_perm * h_prev2
     gen ybarXpost1 = log_inc_perm * h_post1
     gen ybarXpost2 = log_inc_perm * h_post2

     $reg `util' ybarXhit ybarXprev1 h_it h_prev1 single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store adaptX_1
     do calcMUincFE `var' `util' `sample' 0
     est restore adaptX_1
     loneway rnumdis hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybarXhit] / ${mu_`var'_`util'_`s'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybarXhit] / ${mu_`var'_`util'_`s'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`s'}
     global MU_inc_se = ${mu_`var'_`util'_`s'_se}
     rand_areg
     est store adaptX_1
       
     restore



** END for each var (rnumdis, adl_tot, etc.)
}

est drop *fe0*


estout rnumdis_rwhappy_`s' rnumdis_rwhappy_`s'_noxs sp_* adaptX_1 ///
   using ${OUTPUT_DIRECTORY}/tableA3_robustness_`2'_`3'.txt,  ///
 keep(ybar_iXhealth_it health_it ybar_iXshealth_it shealth_it ybarXhit h_it ybarXprev1 h_prev1 ) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
