
set more off

capture program drop add_param
program add_param, eclass
  ereturn scalar `1' = `2'
end


est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



 local var = "rnumdis"
 local util = "rwhappy"
 local sample = 0
 
 *global reg = "areg"
 *global options = " absorb(hhidpn) cluster(hhidpn) "
 * We use xtreg instead of areg following
 *  http://www.kellogg.northwestern.edu/faculty/matsa/htm/fe.htm

 xtset, clear
 xtset hhidpn year
 global reg = "xtreg"
 global options = " fe cluster(hhidpn) "

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'



preserve
matrix disease_weights = J(7,1,0)
local i = 1
capture drop *_dis_it
foreach disease of varlist rhibpe rdiabe rcancre rlunge rhearte rstroke rarthre {
  gen ybar_iX`disease'_dis_it = log_inc_perm * `disease'
  gen `disease'_dis_it = `disease'
  summ `disease' if sample`sample' == 1
  matrix disease_weights[`i',1] = r(mean)
  local i = `i' + 1 
}
local sum = 0 
forvalues i = 1(1)7 {
 local sum = `sum' + disease_weights[`i',1]
}
forvalues i = 1(1)7 {
  matrix disease_weights[`i',1] = disease_weights[`i',1] / `sum'
  local wgt`i' = disease_weights[`i',1]
}
matrix list disease_weights

xtreg `util' *_dis_it single hh_size rage rageSquared _Iw* [aw=wgt] if sample`sample' == 1, fe cluster(hhidpn)     
est store  all_dis
do calcMUincFE "rnumdis" `util' `sample' 0 
est restore all_dis

loneway rnumdis hhidpn if sample0 == 1 & `util' < . & rnumdis < .
local sd = r(sd_w)

di "sd: " `sd' " MU " ${mu_rnumdis_`util'_`sample'}
di " _b " _b[ybar_iXrhibpe_dis_it]

test ///
 _b[ybar_iXrhibpe_dis_it] = ///
 _b[ybar_iXrdiabe_dis_it] = ///
 _b[ybar_iXrcancre_dis_it] = ///
 _b[ybar_iXrlunge_dis_it] = ///
 _b[ybar_iXrhearte_dis_it] = ///
 _b[ybar_iXrstroke_dis_it] = ///
 _b[ybar_iXrarthre_dis_it] 
return list

add_param "Fstat_all_equal" r(F)
global pval_all_equal = 1 - F(r(df), r(df_r), r(F))
add_param "pval_all_equal" $pval_all_equal


lincom ///
(`wgt1' * _b[ybar_iXrhibpe_dis_it] + ///
 `wgt2' * _b[ybar_iXrdiabe_dis_it] + ///
 `wgt3' * _b[ybar_iXrcancre_dis_it] + ///
 `wgt4' * _b[ybar_iXrlunge_dis_it] + ///
 `wgt5' * _b[ybar_iXrhearte_dis_it] + ///
 `wgt6' * _b[ybar_iXrstroke_dis_it] + ///
 `wgt7' * _b[ybar_iXrarthre_dis_it] )
return list

add_param "prev_wgt_b" r(estimate)
add_param "prev_wgt_se" r(se)
global prev_wgt_p = 2 * (1 - normal(abs(r(estimate) / r(se))))
add_param "prev_wgt_p" $prev_wgt_p


lincom ///
`sd' * ///
(`wgt1' * _b[ybar_iXrhibpe_dis_it] + ///
 `wgt2' * _b[ybar_iXrdiabe_dis_it] + ///
 `wgt3' * _b[ybar_iXrcancre_dis_it] + ///
 `wgt4' * _b[ybar_iXrlunge_dis_it] + ///
 `wgt5' * _b[ybar_iXrhearte_dis_it] + ///
 `wgt6' * _b[ybar_iXrstroke_dis_it] + ///
 `wgt7' * _b[ybar_iXrarthre_dis_it] ) / ${mu_rnumdis_`util'_`sample'}

  ** need this for rand_areg to work
  global one_b_over_muinc = r(estimate)
  global one_b_se = r(se)

  global onesd_b_over_muinc = r(estimate)
  global onesd_b_se = r(se)
  global within_se = `sd'
  global MU_inc =  ${mu_rnumdis_`util'_`sample'}
  global MU_inc_se =  ${mu_rnumdis_`util'_`sample'_se}
  rand_areg
  est store all_dis

restore

 estout all_dis ///
  using ${OUTPUT_DIRECTORY}/tableA4_ind_dis.txt, keep( *_dis_it ) ///
  stats( prev_wgt_b prev_wgt_se prev_wgt_p MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se Fstat_all_equal pval_all_equal, fmt(%9.3f)) modelwidth(15) ///
  cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
