
set more off

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


local y = "`4'"


 
 xtset, clear
 xtset hhidpn year
 global reg = "xtreg"
 global options = " fe cluster(hhidpn) "



*local var = "rnumdis"
foreach var of varlist rnumdis radl_tot riadl_tot rofl_tot rh_idx {

local sample = `2'

** (set in loop below)
** local util = "rwhappy"

** rwhappy rcesd4 rcesd 
foreach util of varlist `y' {

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 if (`3' == 0) {
  replace log_inc_perm = log(inc_perm / 1000)
 }
 if (`3' == 1) {
  replace log_inc_perm = raedyrs
 }
 if (`3' == 2) {
  replace log_inc_perm = log(wealth_perm)
 }

 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_inc_perm {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 ** these get rid of singletons(!)
 local s = `sample'
 if ("`util'" == "rbelts") {
   local s = 12
 }
 if ("`util'" == "rprev") {
   local s = 13
 }


 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

}


}

 est drop *fe0*

 estout * ///
   using ${OUTPUT_DIRECTORY}/tableA7_utils_`2'_`3'_`4'.txt, keep(ybar_iXhealth_it health_it ) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se, fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

 exit



