

set more off

capture program drop post_param
program define post_param, eclass
 ereturn scalar `1' = `2'
end


drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



xtset, clear
xtset hhidpn year


**
* get final sample
keep if rwhappy < . 
keep if log_inc_perm < .
keep if single < .
keep if rage < .
keep if isretired < .
keep if hh_size < .
keep if rnumdis < .


** NOTE: Impose this restriction *before* running...
keep if sample0 == 1

**
* drop nursing homes
**
*sort hhid wave rnhmliv
*by hhid wave: drop if rnhmliv[_N] == 1


**
* drop singles
**
if (`2' == 1) {
 keep if alwaysSingle == 1
}


est clear

/**
 ERZO: Instead of using NUM_DISEASE, 
 use FRAC_DISEASE = (NUM_DISEASE / HIGHEST POSSIBLE NUMBER).  
  i.e. divide by 14 for couples, by 7 for individuals.
This will put the disease measure on the same scale for singles and
couples
 **/
assert(hnumdis == rnumdis) if single == 1

replace hnumdis = hnumdis / 2 if single == 0

if (`2' == 2) {
summ hnumdis if single == 1
replace hnumdis = hnumdis / 7 if single == 1
summ hnumdis if single == 0
replace hnumdis = hnumdis / 14 if single == 0
}

** create copy of "real" hhidpn
** NOTE: needs to be a "long"(!!)
capture drop *_copy
gen long hhidpn_copy = hhidpn

summ log_inc_curr


**
** log_inc_curr set to missing for other household measures
**
capture drop myn
sort hhid wave hhidpn log_inc_curr hnumdis single hh_size 
bys hhid wave: gen myn = _n
summ log_inc_curr
replace log_inc_curr = . if myn != 1
summ log_inc_curr
summ hhid, det


gen log_inc_curr_copy = log_inc_curr
capture drop avg_age*
bys hhid wave: egen avg_age = mean(rage)
gen avg_age_squared = avg_age * avg_age

drop hhidpn
replace shhidpn = 0 if shhidpn == .
egen long hhidpn = group(hhidpn_copy shhidpn)

	
foreach var of varlist hnumdis {
 foreach sample of numlist 0 {
  ** foreach util of varlist log_inc_curr log_c log_c_nd log_c_no_h log_c_nd_no_h log_h 
  foreach util of varlist log_inc_curr log_c log_c_nd {

  preserve


  capture drop myN
  sort hhidpn hnumdis
  by hhidpn: gen myN = _N
  replace log_inc_curr = . if myN == 1

  keep if log_inc_perm < .
  if ("`util'" != "log_inc_curr") {
   keep if log_c < . & log_c_nd < . & log_h < . & log_c_no_h < . & log_c_nd_no_h < . 
  }

  summ log_inc_curr hnumdis

  di ""
  di " =============== " 
  di "doing var `var' `util' `sample' ..."
  di ${mu_`var'_`util'_`sample'}
  di " =============== " 

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 foreach xvar of varlist single rage rageSquared avg_age avg_age_squared hh_size wave log_inc_perm log_inc_curr {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }


 capture drop *health_it*
 gen health_it = `var'

 xtreg `util' health_it avg_age avg_age_squared  single hh_size _Iwave* if sample`sample' == 1, fe cluster(hhidpn)
 est store inter1_`util'_`sample'

 gen ybarXwave = log_inc_perm * wave
 xtreg `util' health_it ybarXwave avg_age avg_age_squared  single hh_size _Iwave* if sample`sample' == 1, fe cluster(hhidpn)
 est store inter2_`util'_`sample'

 restore

di "ending foreach util"
** end foreach util var
}

di "ending foreach sample var"
** end foreach sample var
}


estout * ///
 using ${OUTPUT_DIRECTORY}/tableA9_cons_trends`2'.txt , drop(_* *age* single hh_size)  ///
 stats(r2 N within_se, fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit




