set more off

est clear

***
* Tables B0-B5 and Table C
***
local sample = 0
local var    = "rnumdis"
foreach util of varlist rwhappy  rcesd4 rcesd rfracPrev rseatBelts rfracPrevExt r_sh {
 forvalues sample = 0(1)$max_sample {

 **
 * de-mean all non-health variables
 ** 
 foreach xvar of varlist single rage rageSquared hh_size _Iw* log_inc_perm dummy_inc_perm {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

  **forvalues offset = 0/5 {
  local offset = 0

   preserve
   keep if sample`sample' == 1

   capture drop *health_it
   replace `var' = `var' - `offset'
   gen ybar_iXhealth_it   = log_inc_perm * `var'
   gen dummyY_iXhealth_it = dummy_inc_perm * `var'
   gen health_it = `var'

   $reg `util'  health_it dummyY_iXhealth_it ybar_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`sample' == 1 , $options
   capture drop fe
   capture drop myn
   capture drop myN
   predict fe, d
   bys hhidpn: gen myn = _n
   bys hhidpn: gen myN = _N
   reg fe log_inc_perm dummy_inc_perm if myn == 1
   est store `var'_`util'_`sample'_fe`offset'
   reg fe log_inc_perm dummy_inc_perm [aw=myN] if myn == 1
   global mu_rnumdis_
   est store `var'_`util'_`sample'_fe`offset'w


   restore

  }
}





forvalues offset = 0(1)5 {
 estout *0_fe`offset'  *0_fe`offset'w ///
  using /bbkinghome/noto/stateDependentUtility/rand/tableB`offset'.txt, drop (*dummy* *cons*) ///
  stats(r2 N one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se within_se MU_inc, fmt(%9.3f %9.0g)) modelwidth(15) ///
  cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
 est drop *_fe`offset'  *_fe`offset'w
}

