set more off

est clear

local sample = 0

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 foreach xvar of varlist single rage rageSquared hh_size _Iw* log_inc_perm dummy_inc_perm {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

** take results from previous and put in matrix
matrix disease_shocks = J(70,3,0)


local y = 1
foreach util of varlist rwhappy {
  **rcesd4 rcesd {
   local x = 1
   foreach disease of varlist rhibpe rdiabe rcancre rlunge rhearte rstroke rarthre rpsyche med_* diab_sev diab_sev2 lung_oxy stroke_sev stroke_sev2  {
    if ("`disease'" == "med_tot" | "`disease'" == "med_frac") {
     di "SKIPPING `disease' ..."
    }
    else {
     preserve
     capture drop *health_it 
     gen health_it = `disease'
     gen ybar_iXhealth_it = log_inc_perm * `disease'
     gen dummyY_iXhealth_it = dummy_inc_perm * `disease'
     areg `util' health_it ybar_iXhealth_it single hh_size rage rageSquared _Iw* [aw=wgt] if sample`sample' == 1, absorb(hhidpn) cluster(hhidpn)     
     est store   d_`disease'_`y'
     do calcMUincFE "rnumdis" `util' `sample' 0 
     est restore   d_`disease'_`y'

     loneway health_it hhidpn if sample0 == 1 & `util' < . & rnumdis < .
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_rnumdis_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_rnumdis_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc =  ${mu_rnumdis_`util'_`sample'}
     global MU_inc_se =  ${mu_rnumdis_`util'_`sample'_se}
     rand_areg
     est store d_`disease'_`y'

     areg `util' health_it single hh_size rage rageSquared _Iw* [aw=wgt] if sample`sample' == 1, absorb(hhidpn) cluster(hhidpn)     
     matrix disease_shocks[`x', `y'] = _b[health_it]
     local x = `x' + 1

     restore

    ** end else
    }

   }
   local y = `y' + 1
}

local util = "rwhappy"
local sample = 0

preserve
matrix disease_weights = J(7,1,0)
local i = 1
capture drop *_dis_it
foreach disease of varlist rhibpe rdiabe rcancre rlunge rhearte rstroke rarthre {
  gen ybar_iX`disease'_dis_it = log_inc_perm * `disease'
  gen `disease'_dis_it = `disease'
  summ `disease' if sample`sample' == 1
  matrix disease_weights[`i',1] = r(mean)
  local i = `i' + 1 
}
local sum = 0 
forvalues i = 1(1)7 {
 local sum = `sum' + disease_weights[`i',1]
}
forvalues i = 1(1)7 {
  matrix disease_weights[`i',1] = disease_weights[`i',1] / `sum'
  local wgt`i' = disease_weights[`i',1]
}
matrix list disease_weights

areg `util' *_dis_it single hh_size rage rageSquared _Iw* [aw=wgt] if sample`sample' == 1, absorb(hhidpn) cluster(hhidpn)     
est store  all_dis
do calcMUincFE "rnumdis" `util' `sample' 0 
est restore all_dis

loneway rnumdis hhidpn if sample0 == 1 & `util' < . & rnumdis < .
local sd = r(sd_w)

di "sd: " `sd' " MU " ${mu_rnumdis_`util'_`sample'}
di " _b " _b[ybar_iXrhibpe_dis_it]

test ///
 _b[ybar_iXrhibpe_dis_it] = ///
 _b[ybar_iXrdiabe_dis_it] = ///
 _b[ybar_iXrcancre_dis_it] = ///
 _b[ybar_iXrlunge_dis_it] = ///
 _b[ybar_iXrhearte_dis_it] = ///
 _b[ybar_iXrstroke_dis_it] = ///
 _b[ybar_iXrarthre_dis_it] 

lincom ///
(`wgt1' * _b[ybar_iXrhibpe_dis_it] + ///
 `wgt2' * _b[ybar_iXrdiabe_dis_it] + ///
 `wgt3' * _b[ybar_iXrcancre_dis_it] + ///
 `wgt4' * _b[ybar_iXrlunge_dis_it] + ///
 `wgt5' * _b[ybar_iXrhearte_dis_it] + ///
 `wgt6' * _b[ybar_iXrstroke_dis_it] + ///
 `wgt7' * _b[ybar_iXrarthre_dis_it] )

lincom ///
`sd' * ///
(`wgt1' * _b[ybar_iXrhibpe_dis_it] + ///
 `wgt2' * _b[ybar_iXrdiabe_dis_it] + ///
 `wgt3' * _b[ybar_iXrcancre_dis_it] + ///
 `wgt4' * _b[ybar_iXrlunge_dis_it] + ///
 `wgt5' * _b[ybar_iXrhearte_dis_it] + ///
 `wgt6' * _b[ybar_iXrstroke_dis_it] + ///
 `wgt7' * _b[ybar_iXrarthre_dis_it] ) / ${mu_rnumdis_`util'_`sample'}

**  lincom `sd' * _b[ybar_iXhealth_it] / ${mu_rnumdis_`util'_`sample'}

  global onesd_b_over_muinc = r(estimate)
  global onesd_b_se = r(se)
  global within_se = `sd'
  global MU_inc =  ${mu_rnumdis_`util'_`sample'}
  global MU_inc_se =  ${mu_rnumdis_`util'_`sample'_se}
  rand_areg
  est store all_dis

restore



capture drop rnumdis_wgt*

matrix list disease_shocks
local y = 1
gen rnumdis_wgt_rwhappy = ///
  disease_shocks[1,`y'] * rhibpe + ///
  disease_shocks[2,`y'] * rdiabe + ///
  disease_shocks[3,`y'] * rcancre + ///
  disease_shocks[4,`y'] * rlunge + ///
  disease_shocks[5,`y'] * rhearte + ///
  disease_shocks[6,`y'] * rstroke + ///
  disease_shocks[7,`y'] * rarthre 
replace rnumdis_wgt_rwhappy = ///
 rnumdis_wgt_rwhappy / (disease_shocks[1,`y'] + disease_shocks[2,`y'] + disease_shocks[3,`y'] + disease_shocks[4,`y'] + disease_shocks[5,`y'] + disease_shocks[6,`y'] + disease_shocks[7,`y'])

/**
estout d_rlunge_1 d_lung_oxy_1  d_rdiabe_1 d_diab_sev_1 d_diab_sev2_1 d_rstroke_1 d_stroke_sev_1 d_stroke_sev2_1 ///
   using /bbkinghome/noto/stateDependentUtility/rand/tableD2.txt, keep( health_it ybar_iXhealth_it) ///
 stats(MU_inc r2 N ind_N within_se one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f %9.0g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
**/
**est drop  d_rlunge_1 d_lung_oxy_1 d_rdiabe_1 d_diab_sev_1 d_diab_sev2_1 d_rstroke_1 d_stroke_sev_1 d_stroke_sev2_1
**estout d_*1 

**estout d_rhibpe_1 d_rdiabe_1 d_rcancre_1 d_rlunge_1 d_rhearte_1 d_rstroke_1 d_rarthre_1 all_dis 
estout all_dis ///
   using /bbkinghome/noto/stateDependentUtility/rand/table8_indv_dis.txt, keep( *_dis_it) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f %9.0g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

est drop d_*

exit

local y = 2
gen rnumdis_wgt_rcesd4 = ///
  disease_shocks[1,`y'] * rhibpe + ///
  disease_shocks[2,`y'] * rdiabe + ///
  disease_shocks[3,`y'] * rcancre + ///
  disease_shocks[4,`y'] * rlunge + ///
  disease_shocks[5,`y'] * rhearte + ///
  disease_shocks[6,`y'] * rstroke + ///
  disease_shocks[7,`y'] * rarthre 
replace rnumdis_wgt_rcesd4 = ///
 rnumdis_wgt_rcesd4 / (disease_shocks[1,`y'] + disease_shocks[2,`y'] + disease_shocks[3,`y'] + disease_shocks[4,`y'] + disease_shocks[5,`y'] + disease_shocks[6,`y'] + disease_shocks[7,`y'])

local y = 3
gen rnumdis_wgt_rcesd = ///
  disease_shocks[1,`y'] * rhibpe + ///
  disease_shocks[2,`y'] * rdiabe + ///
  disease_shocks[3,`y'] * rcancre + ///
  disease_shocks[4,`y'] * rlunge + ///
  disease_shocks[5,`y'] * rhearte + ///
  disease_shocks[6,`y'] * rstroke + ///
  disease_shocks[7,`y'] * rarthre 
replace rnumdis_wgt_rcesd = ///
 rnumdis_wgt_rcesd / (disease_shocks[1,`y'] + disease_shocks[2,`y'] + disease_shocks[3,`y'] + disease_shocks[4,`y'] + disease_shocks[5,`y'] + disease_shocks[6,`y'] + disease_shocks[7,`y'])


estout d_*3 ///
   using /bbkinghome/noto/stateDependentUtility/rand/tableE.txt, keep( health_it ybar_iXhealth_it) ///
 stats(r2 N ind_N within_se MU_inc one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f %9.0g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
est drop d_*3

estout d_*2 ///
   using /bbkinghome/noto/stateDependentUtility/rand/tableF.txt, keep( health_it ybar_iXhealth_it) ///
 stats(r2 N ind_N within_se MU_inc one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f %9.0g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
est drop d_*2



