set more off

**
* different income adjustment
** 

est clear

capture drop one
gen one = 1

**
* de-mean all non-health variables
foreach xvar of varlist single rage rageSquared hh_size _Iw* log_inc_perm dummy_inc_perm {
 qui summ `xvar' if sample0 == 1
 qui replace `xvar' = `xvar' - r(mean)
}

local sample = 0
local util = "rwhappy" 
 foreach adj of varlist oecd_adj oecd_adj_full sqrt_adj per_cap_full per_cap_partial one {

  di "====="
  di "MU of income: `util', `adj' ..."
  di ${`util'_`adj'}
  di "====="

  preserve


  capture drop *health_it
  gen health_it = rnumdis
  gen ybar_iXhealth_it = log_inc_perm * health_it * oecd_adj / `adj'
  gen dummyYXhealth_it = dummy_inc_perm * health_it

  areg `util' *health_it single hh_size rage rageSquared _Iw* [aw=wgt] if sample0 == 1, absorb(hhidpn) cluster(hhidpn)     

  est store `adj'_`sample'
  do calcMUincFE `util' `sample' `sample' 0
  est restore `adj'_`sample'

  loneway health_it hhidpn if sample0 == 1  & `util' < . & rnumdis < .
  local sd = r(sd_w)
  lincom _b[ybar_iXhealth_it] / ${mu_`util'_`sample'_`sample'}
  global one_b_over_muinc = r(estimate)
  global one_b_se = r(se)
  lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`util'_`sample'_`sample'}
  global onesd_b_over_muinc = r(estimate)
  global onesd_b_se = r(se)
  global within_se = `sd'
  global MU_inc = ${mu_`util'_`sample'_`sample'}
  rand_areg
  est store `adj'_`sample'
  restore

 }
*}

estout * ///
  using /bbkinghome/noto/stateDependentUtility/rand/tableG.txt, drop( _I* *age* *dummy* *single* *cons* *hh_size*) ///
  stats(r2 N ind_N within_se MU_inc one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se, fmt(%9.3f)) modelwidth(15) ///
  cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
