set more off


/**
 REGRESSION OF CESD INDEX ON LOG PERMANENT INCOME (WITHOUT CONTROLS)
 **/

capture drop one
gen one = 1

est clear

foreach util of varlist rcesd rwhappy rcesd_smith {
  foreach adj of varlist oecd_adj oecd_adj_full sqrt_adj per_cap_full per_cap_partial one {


    di "=========="
    di " calculate MU of income util: `util', adj: `adj'"
    di "=========="

    preserve
    replace log_inc_perm = log_inc_perm * oecd_adj / `adj' 
    reg `util' log_inc_perm dummy_inc_perm isfemale isblack rage rageSquared single hh_size rnumdis _Iwave* if sample0 == 1, cluster(hhidpn)
    global `util'_`adj'  = _b[log_inc_perm]
    est store `util'_`adj'
    restore
 }
}

estout * ///
 using /bbkinghome/noto/stateDependentUtility/rand/tableM.txt, ///
 stats(r2 N, fmt(%9.3f %9.0g)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 
