
set more off

capture program drop post_param
program define post_param, eclass
 ereturn scalar `1' = `2'
end

capture program drop mydetrend
program mydetrend, rclass byable(recall)
syntax varlist [if] [in], DETrend(varname)
qui {
tempvar eps
marksample touse
count if `touse'
if (r(N) > 2) {
 regress `varlist' if `touse'
 predict double `eps' if e(sample), res
 replace `detrend' = `eps' if e(sample)
}
}
end




est clear
drop _all
use /tmp/bsample_`1'.dta

**
* NOTE: Konrad says you need to create separate panel ID variable each time HHIDPN is resampled
**
summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


if ("${OUTPUT_DIRECTORY}" == "") {
 di "=============="
 di " WARNING: setting output directory to /proj/matt/stateDependentUtility/rand/output/base"
 di "=============="
} 

local sample = `2'
local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev


*gen rand = uniform()
*sort hhidpn rand
*by hhidpn: keep if rand[1] < 0.005
*drop rand




*local var = "rnumdis"
foreach var of varlist rnumdis radl_tot riadl_tot rofl_tot rh_idx {
*foreach var of varlist rnumdis {



 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **

 if (`3' == 0) {
  replace log_inc_perm = log(inc_perm / 1000)
 }
 if (`3' == 1) {
  replace log_inc_perm = raedyrs
 }


 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_inc_perm {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store   `var'_`util'_`s'


 preserve

 summ wave
 replace wave = wave + 1 - r(min)
 sort hhidpn wave
 by hhidpn: keep if wave[_N] == 7

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'_nodrop
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'_nodrop
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store   `var'_`util'_`s'_nodrop

 restore

 kaboom









*******************
** catch all!!
*******************

     preserve
     ** interact everything with income (!!) 
     gen double ybarXhh_size = log_inc_perm * hh_size
     gen double ybarXrage = log_inc_perm * rage
     gen double ybarXsingle = log_inc_perm * single
     $reg `util' *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store ints_`var'
     do calcMUincFE `var' `util' `sample' 0
     est restore ints_`var'
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store ints_`var'
     restore

     preserve
     ** interact everything with income (!!) 
     gen ybarXhh_size = log_inc_perm * hh_size
     gen ybarXrage = log_inc_perm * rage
     gen ybarXsingle = log_inc_perm * single
     $reg `util' *health_it ybarXhh_size ybarXsingle ybarXrage single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store ints2_`var'
     do calcMUincFE `var' `util' `sample' 0
     est restore ints2_`var'
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store ints2_`var'
     restore




/**
 **
     preserve

     capture drop _I*
     xi i.hhidpn*rage i.wave
     *xi i.hhidpn*rage
     drop _Ihhidpn*
     drop dummy*

     ** interact everything with income (!!) 
     gen ybarXhh_size = log_inc_perm * hh_size
     gen ybarXsingle = log_inc_perm * single
     **$reg `util' *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared _I* if sample`sample' == 1, $options
     $reg `util' *health_it  ybarXhh_size ybarXsingle single hh_size rageSquared _I* if sample`sample' == 1, $options
     est store ints3_`var'
     do calcMUincFE `var' `util' `sample' 0
     est restore ints3_`var'
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg
     est store ints3_`var'

     restore




     preserve

     keep if sample0 == 1

     gen ybarXhh_size = log_inc_perm * hh_size
     gen ybarXsingle = log_inc_perm * single

     drop dummy*

     gen rage_orig = rage

     di "de-trending variable rwhappy ..."
     gen rwhappy_det = .
     qui {
      bys hhidpn: mydetrend rwhappy rage_orig, det(rwhappy_det)
     }
     foreach v of varlist *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared _Iw* {
      di "de-trending variable `v'..."
      gen `v'_det = .
      qui {
       bys hhidpn: mydetrend `v' rage_orig, det(`v'_det)
      }
     }

     foreach v of varlist rwhappy *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared {
      drop `v'
      rename `v'_det `v'
     }

     *areg rwhappy_det *health_it_det ybarXhh_size_det ybarXsingle_det single_det hh_size_det, absorb(hhidpn) cluster(hhidpn)
     *reg rwhappy *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared _Iw*_det, cluster(hhidpn)
     areg rwhappy *health_it ybarXhh_size ybarXsingle single hh_size rageSquared _Iw*_det, absorb(hhidpn) cluster(hhidpn)

     est store ints4_`var'
     do calcMUincFE `var' `util' `sample' 0
     est restore ints4_`var'
     loneway health_it hhidpn if e(sample) == 1
     local sd = r(sd_w)
     lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global one_b_over_muinc = r(estimate)
     global one_b_se = r(se)
     lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`sample'}
     global onesd_b_over_muinc = r(estimate)
     global onesd_b_se = r(se)
     global within_se = `sd'
     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     rand_areg

     est store ints4_`var'

     restore
 **
 **/



     preserve

     keep if sample`sample' == 1

     gen ybarXhh_size = log_inc_perm * hh_size
     gen ybarXsingle = log_inc_perm * single

     drop dummy*

     gen rage_orig = rage

     di "de-trending variable rwhappy ..."

     capture drop rwhappy_det
     gen rwhappy_det = .
     qui {

      capture drop mean_rwhappy
      bys hhidpn: egen mean_rwhappy = mean(rwhappy)
      bys hhidpn: egen mean_rage    = mean(rage_orig)
      replace rwhappy = rwhappy - mean_rwhappy
      replace rage_orig = rage_orig - mean_rage

      bys hhidpn: egen sd_rage = sum(rage_orig*rage_orig)

      bys hhidpn: egen cov = sum(rage_orig*rwhappy)
      
      gen coeff = cov / (sd_rage)

      replace rwhappy_det = rwhappy - coeff * rage_orig

     }
     foreach v of varlist *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared _Iw* {
      di "de-trending variable `v'..."

       qui {
      capture drop mean_`v'
      bys hhidpn: egen mean_`v' = mean(`v')
      replace `v' = `v' - mean_`v'
      drop mean_`v'

      capture drop cov
      bys hhidpn: egen cov = sum(rage_orig*`v')

      capture drop coeff      
      bys hhidpn: gen coeff = cov / (sd_rage)

      replace coeff = 0 if missing(coeff)

      gen `v'_det = `v' - coeff * rage_orig
 
       }

     }

     foreach v of varlist rwhappy *health_it ybarXhh_size ybarXsingle single hh_size rage rageSquared {
      drop `v'
      rename `v'_det `v'
     }

     *areg rwhappy_det *health_it_det ybarXhh_size_det ybarXsingle_det single_det hh_size_det, absorb(hhidpn) cluster(hhidpn)
     areg rwhappy *health_it ybarXhh_size ybarXsingle single hh_size rageSquared _Iw*_det, absorb(hhidpn) cluster(hhidpn)
     est store ints5_`var'

     predict resid, resid
     bys hhidpn: egen fe = mean(resid)
     summ fe, det
   
     matrix eb = e(b)

     restore







     preserve

     keep if sample`sample' == 1

     gen ybarXhh_size = log_inc_perm * hh_size
     gen ybarXsingle = log_inc_perm * single

     local i = 1
     
     *summ rwhappy
     *replace rwhappy = rwhappy - r(mean)

     drop dummy*

     gen resid = rwhappy
     foreach v of varlist *health_it ybarXhh_size ybarXsingle single hh_size rageSquared _Iw* {
      di "doing variable `v'..."
      replace resid = resid - eb[1,`i'] * `v'
      local i = `i' + 1
     }

     capture drop myN 
     bys hhidpn: gen myN = _N

     bys hhidpn: egen fe = mean(resid)
     summ fe, det
     summ fe if myN < 3, det

     gen rage_orig = rage

     local v = "resid"

      capture drop mean_`v'
      bys hhidpn: egen mean_`v' = mean(`v')
      bys hhidpn: egen mean_rage    = mean(rage_orig)
      replace `v' = `v' - mean_`v'
      replace rage_orig = rage_orig - mean_rage
      drop mean_`v'

      bys hhidpn: egen sd_rage = sum(rage_orig*rage_orig)

      capture drop cov
      bys hhidpn: egen cov = sum(rage_orig*`v')

      capture drop coeff      
      bys hhidpn: gen coeff = cov / (sd_rage)

      replace coeff = 0 if missing(coeff)

     replace fe = fe - coeff * mean_rage
     summ fe, det
     summ fe if myN < 3, det

     reg fe log_inc_perm isfemale isblack rage rageSquared single hh_size, cluster(hhidpn)        

 restore


}


est drop *fe0*

estout * ///
 using ${OUTPUT_DIRECTORY}/tableZ_catchall_`2'_`3'.txt, drop( _* rage* hh_size single *dummy*) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit
