
set more off

capture program drop add_param
program add_param, eclass
 ereturn scalar `1' = `2'
end

est clear
drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



** set in loop below
* local var = "rnumdis"

local sample = 0
local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev


** sort hhidpn wave
** outsheet hhidpn hhid wave sample0 rage single hasHealthInsurance isretired *numdis using /tmp/hhidpn.txt, replace
** kaboom

local var = "rnumdis"

 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)


 capture drop *health_it

 if ("`2'" != "") { 
   local alpha = `2'
   summ log_inc_perm
   capture drop log_inc_perm
   gen double log_inc_perm = ( (inc_perm/10000) ^ (1 - `alpha')) / (1 - `alpha')
 }
 else {
  ** don't replace log_inc_perm 
 }


 foreach xvar of varlist single hh_size _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 capture drop ybar_iXhealth_it
 gen double ybar_iXhealth_it   = log_inc_perm * `var'

 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'


 local s = `sample'
 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

 assert(isretired == 1) if sample`s' == 1
 assert(rgovmr == 1) if rage >= 65

 preserve
 foreach s of numlist 15 {

 foreach xvar of varlist single hh_size _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`s' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 capture drop ybar_iXhealth_it
 gen double ybar_iXhealth_it   = log_inc_perm * `var'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 & (rgovmr == 1), $options
 do helper "mr`s'" "`var'" "`util'" "`s'"

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 & (rgovmr == 1 & rgovmd == 1), $options
 do helper "mr_md`s'" "`var'" "`util'" "`s'"

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 & (rgovmr == 1 & (rgovmd == 1 | rgovva == 1 | mcareHMO == 1)), $options
 do helper "mr_md_va_hmo`s'" "`var'" "`util'" "`s'"

 ** $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 & (rgovmr == 1 & (rgovmd == 1 | mcareHMO == 1)), $options
 ** do helper "mr_md_hmo`s'" "`var'" "`util'" "`s'"

 }
 restore


 preserve
 foreach s of numlist 6 {

 foreach xvar of varlist single hh_size _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`s' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 capture drop ybar_iXhealth_it
 gen double ybar_iXhealth_it   = log_inc_perm * `var'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 & (rgovmr == 1), $options
 do helper "mr`s'" "`var'" "`util'" "`s'"

 }
 restore




 preserve
 local s = 0
 replace ybar_iXhealth_it = log_inc_perm * (rnumdis >= 2)
 replace health_it = rnumdis >= 2
 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store dummy
 do calcMUincFE `var' `util' `s' 1
 est restore dummy
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store dummy
 restore


est drop *fe*
estout * ///
 using tableZ_medicare_samples`2'.txt,  drop(_* dummy* rage* single hh_size) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 


exit


