
global OUTPUT_DIRECTORY = "./output/"

set more off

est clear

drop _all
use /tmp/bsample_`1'.dta

summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



 local var = "rnumdis"
 local util = "rwhappy"
* local sample = 0

 gen sample24 = sample0 & (isfemale == 1) 
 gen sample25 = sample0 & (isfemale == 0) 

 gen sample26 = sample15 & (isfemale == 1) 
 gen sample27 = sample15 & (isfemale == 0) 

 *local samples = "0 24 25 15 26 27"

 local samples = "0 24 25 15 26 27"

 foreach sample of local samples {

** xtset hhidpn

 global reg = "areg"
 global options = " absorb(hhidpn) cluster(hhidpn) "

* global reg = "xtreg"
* global options = " fe vce(cluster hhidpn)"

 di ""
 di " =============== " 
 di "doing var `var' `util' `sample' ..."
 di ${mu_`var'_`util'_`sample'}
 di " =============== " 
 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  di "doing variable `xvar' ..."
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

 capture drop *health_it

 if (`2' == 1) {
  replace log_inc_perm = raedyrs
 }

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

 if (`s' == 0 | `s' == 15) {

 capture drop h_itX*
 capture drop *Xh_itX*

 gen ybar_iXh_itXfemale = ybar_iXhealth_it * (isfemale == 1)
 gen ybar_iXh_itXmale = ybar_iXhealth_it * (isfemale == 0)
 gen h_itXfemale = health_it * (isfemale == 1)
 gen h_itXmale = health_it * (isfemale == 0)

 gen singleXfemale = single * (isfemale == 1)
 gen hh_sizeXfemale = hh_size * (isfemale == 1)
 gen rageXfemale = rage * (isfemale == 1)
 gen rageSquaredXfemale = rageSquared * (isfemale == 1)

 foreach v of varlist _Iwave* {
  capture drop `v'Xfemale
  gen `v'Xfemale = `v' * (isfemale == 1)
 }


 $reg `util'  *Xfemale *Xmale rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store Xfemale

 loneway health_it hhidpn if isfemale == 1 & e(sample) == 1
 local sd_f = r(sd_w)
 loneway health_it hhidpn if isfemale == 0 & e(sample) == 1
 local sd_m = r(sd_w)

 preserve
 predict fe, d
 reg fe log_inc_perm isfemale isblack rage rageSquared single hh_size if isfemale == 1, cluster(hhidpn)        
 global MU_inc_f = _b[log_inc_perm]
 reg fe log_inc_perm isfemale isblack rage rageSquared single hh_size if isfemale == 0, cluster(hhidpn)        
 global MU_inc_m = _b[log_inc_perm]
 restore

 di "vals: `sd_f', `sd_m', $MU_inc_f, $MU_inc_m ..."

 est restore Xfemale
 test ybar_iXh_itXfemale == ybar_iXh_itXmale
 return list
 global pval0 = r(p) 
 test ybar_iXh_itXfemale * (`sd_f'/$MU_inc_f) == ybar_iXh_itXmale * (`sd_m'/$MU_inc_m)
 return list
 global pval1 = r(p) 
 test h_itXfemale == h_itXmale
 global pval2 = r(p) 
 pval
 est store base`s'_inter

 capture drop *Xfemale
 capture drop *Xmale

 }

 }


est drop *fe*

estout * ///
 using ${OUTPUT_DIRECTORY}/tableZ_jeea1_`2'.txt, keep(ybar_iXhealth_it health_it *h_it*) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se pval0 pval1 pval2, fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

