


set more off

est clear

drop _all
use /tmp/bsample_`1'.dta





gen pca_happy = rwhappy
gen pca_enlife= renlife
gen pca_sad   = 1-rfsad
gen pca_lone  = 1-rflone
gen pca_going = 1-rgoing
gen pca_sleep = 1-rsleepr
gen pca_effort= 1-reffort
gen pca_depres= 1-rdepres

pca  pca_* if sample0 == 1
ereturn list
return list

pca  pca_* if sample0 == 1, components(1)
matrix v = e(L)

gen pca = ///
 v[1,1] * pca_happy + ///
 v[2,1] * pca_enlife+ ///
 v[3,1] * pca_sad   + ///
 v[4,1] * pca_lone  + ///
 v[5,1] * pca_effort+ ///
 v[6,1] * pca_depres+ ///
 v[7,1] * pca_going + ///
 v[8,1] * pca_sleep


corr rnumdis radl_tot riadl_tot rofl_tot rh_idx r_sh

corr rcesd rcesd4 rwhappy


summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 



 local var = "rnumdis"
* local util = "rwhappy"
 local sample = 0

 local utils = "rwhappy pca"
 foreach util of local utils {

* xtset hhidpn

 global reg = "areg"
 global options = " absorb(hhidpn) cluster(hhidpn) "

* global reg = "xtreg"
* global options = " fe vce(cluster hhidpn)"

 di ""
 di " =============== " 
 di "doing var `var' `util' `sample' ..."
 di ${mu_`var'_`util'_`sample'}
 di " =============== " 
 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

 }


est drop *fe*

estout * ///
 using ${OUTPUT_DIRECTORY}/tableZ_jeea2.txt, keep(ybar_iXhealth_it health_it) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se one_b_over_muinc one_b_se onesd_b_over_muinc onesd_b_se, fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

