
set more off

capture program drop post_param
program define post_param, eclass
 ereturn scalar `1' = `2'
end

est clear
drop _all
use /tmp/bsample_`1'.dta

**
* NOTE: Konrad says you need to create separate panel ID variable each time HHIDPN is resampled
**
summ hhidpn
local max_hhidpn = r(max)
sort hhidpn wave
by hhidpn wave: replace hhidpn = (`max_hhidpn' + 1) * (_n - 1) + hhidpn 


local sample = 0
local util = "rwhappy"
 
global reg = "areg"
global options = " absorb(hhidpn) cluster(hhidpn) "

rename rseatBelts rbelts
rename rfracPrevExt rprev

local var = "rnumdis"
local sample = 0



 **
 * de-mean all non-health variables
 ** NOTE: if health is included we get change in MU for inc in permanent income at MEAN health
 **
 replace log_inc_perm = log(inc_perm / 1000)
 replace wealth_perm = . if wealth_perm < 1000
 capture drop log_wealth_perm
 gen log_wealth_perm = log(wealth_perm)
 foreach xvar of varlist single rage rageSquared hh_size wave _Iw* log_wealth_perm log_inc_perm dummy_inc_perm dummy_inc_curr raedyrs log_c {
  qui summ `xvar' if sample`sample' == 1
  qui replace `xvar' = `xvar' - r(mean)
 }
 summ inc_perm if sample0 == 1
 replace log_inc_curr = log_inc_curr - log(r(mean))

 capture drop *health_it

 gen double ybar_iXhealth_it   = log_inc_perm * `var'
 gen dummyY_iXhealth_it = 0
 assert(dummy_inc_perm == 0)
 
 gen health_it = `var'

 local s = `sample'

 $reg `util'  ybar_iXhealth_it health_it dummyY_iXhealth_it rage rageSquared single hh_size _Iwave* if sample`s' == 1 , $options
 est store   `var'_`util'_`s'
 do calcMUincFE `var' `util' `s' 1
 est restore `var'_`util'_`s'
 loneway health_it hhidpn if e(sample) == 1
 local sd = r(sd_w)
 lincom _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global one_b_over_muinc = r(estimate)
 global one_b_se = r(se)
 lincom `sd' * _b[ybar_iXhealth_it] / ${mu_`var'_`util'_`s'}
 global onesd_b_over_muinc = r(estimate)
 global onesd_b_se = r(se)
 global within_se = `sd'
 global MU_inc = ${mu_`var'_`util'_`s'}
 global MU_inc_se = ${mu_`var'_`util'_`s'_se}
 rand_areg
 est store `var'_`util'_`s'

 keep if e(sample) == 1

*******************
** # of diseases
*******************

     preserve
     capture drop *health_it
     forvalues d = 1(1)6 { 
       gen ybar_iXh`d'_it = log_inc_perm * (rnumdis >= `d')
     }
     forvalues d = 1(1)6 { 
       gen h`d'_it = (rnumdis >= `d')
     }
     $reg `util' ybar_iXh*it h*_it single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store numdis_1_6
     do calcMUincFE `var' `util' `sample' 0
     est restore numdis_1_6

     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se

     test /// 
       _b[ybar_iXh1_it] = _b[ybar_iXh2_it] = _b[ybar_iXh3_it] = _b[ybar_iXh4_it] = _b[ybar_iXh5_it] = _b[ybar_iXh6_it]
     post_param "F_yXhit_eq" r(F)
     post_param "p_yXhit_eq" r(p)
     post_param "df_yXhit_eq" r(df)
     post_param "df_r_yXhit_eq" r(df_r)

     test /// 
       _b[h1_it] = _b[h2_it] = _b[h3_it] = _b[h4_it] = _b[h5_it] = _b[h6_it]
     post_param "F_hit_eq" r(F)
     post_param "p_hit_eq" r(p)
     post_param "df_hit_eq" r(df)
     post_param "df_r_hit_eq" r(df_r)

**     lincom /// 
**       _b[ybar_iXh1_it] + _b[ybar_iXh2_it] +_b[ybar_iXh3_it] + _b[ybar_iXh4_it] + _b[ybar_iXh5_it] + _b[ybar_iXh6_it]
**     lincom /// 
**       _b[h1_it] + _b[h2_it] + _b[h3_it] + _b[h4_it] + _b[h5_it]

     est store numdis_1_6
     restore



     preserve
     capture drop *health_it
     forvalues d = 1(1)5 { 
       gen ybar_iXh`d'_it = log_inc_perm * (rnumdis >= `d')
     }
     forvalues d = 1(1)5 { 
       gen h`d'_it = (rnumdis >= `d')
     }
     $reg `util' ybar_iXh*it h*_it single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store numdis_1_5
     do calcMUincFE `var' `util' `sample' 0
     est restore numdis_1_5

     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se

     test /// 
       _b[ybar_iXh1_it] = _b[ybar_iXh2_it] = _b[ybar_iXh3_it] = _b[ybar_iXh4_it] = _b[ybar_iXh5_it]
     post_param "F_yXhit_eq" r(F)
     post_param "p_yXhit_eq" r(p)
     post_param "df_yXhit_eq" r(df)
     post_param "df_r_yXhit_eq" r(df_r)

     test /// 
       _b[h1_it] = _b[h2_it] = _b[h3_it] = _b[h4_it] = _b[h5_it]
     post_param "F_hit_eq" r(F)
     post_param "p_hit_eq" r(p)
     post_param "df_hit_eq" r(df)
     post_param "df_r_hit_eq" r(df_r)

**     lincom /// 
**      _b[ybar_iXh1_it] + _b[ybar_iXh2_it] +_b[ybar_iXh3_it] + _b[ybar_iXh4_it] + _b[ybar_iXh5_it]
**     lincom /// 
**       _b[h1_it] + _b[h2_it] + _b[h3_it] + _b[h4_it] + _b[h5_it]
     est store numdis_1_5
     restore


     preserve
     capture drop *health_it
     forvalues d = 1(1)4 { 
       gen ybar_iXh`d'_it = log_inc_perm * (rnumdis >= `d')
     }
     forvalues d = 1(1)4 { 
       gen h`d'_it = (rnumdis >= `d')
     }
     $reg `util' ybar_iXh*it h*_it single hh_size rage rageSquared _Iw* if sample`sample' == 1, $options
     est store numdis_1_4
     do calcMUincFE `var' `util' `sample' 0
     est restore numdis_1_4

     global MU_inc = ${mu_`var'_`util'_`sample'}
     global MU_inc_se = ${mu_`var'_`util'_`sample'_se}
     post_param "MU_inc" $MU_inc
     post_param "MU_inc_se" $MU_inc_se

     test /// 
       _b[ybar_iXh1_it] = _b[ybar_iXh2_it] = _b[ybar_iXh3_it] = _b[ybar_iXh4_it]
     post_param "F_yXhit_eq" r(F)
     post_param "p_yXhit_eq" r(p)
     post_param "df_yXhit_eq" r(df)
     post_param "df_r_yXhit_eq" r(df_r)

     test /// 
       _b[h1_it] = _b[h2_it] = _b[h3_it] = _b[h4_it]
     post_param "F_hit_eq" r(F)
     post_param "p_hit_eq" r(p)
     post_param "df_hit_eq" r(df)
     post_param "df_r_hit_eq" r(df_r)

**     lincom /// 
**       _b[ybar_iXh1_it] + _b[ybar_iXh2_it] +_b[ybar_iXh3_it] + _b[ybar_iXh4_it]
**     lincom /// 
**       _b[h1_it] + _b[h2_it] + _b[h3_it] + _b[h4_it]
     est store numdis_1_4
     restore

estout rnumdis_rwhappy_0 numdis_1_6 numdis_1_5 numdis_1_4 ///
 using ${OUTPUT_DIRECTORY}/tableZ_katz.txt, keep(ybar_i* h*it) ///
 stats(MU_inc MU_inc_se r2 N ind_N within_se onesd_b_over_muinc onesd_b_se F_yXhit_eq p_yXhit_eq df_yXhit_eq df_r_yXhit_eq  F_hit_eq p_hit_eq df_hit_eq df_r_hit_eq , fmt(%9.3f)) modelwidth(15) ///
 cells(b( fmt(%9.3f)) se(par fmt(%9.3f)) p(par([ ]) fmt(%9.3f)) ) style(tab) replace notype mlabels(, numbers ) 

exit
