
*
* initialize shiller data into matrix
**
drop _all
use shiller
drop if annual_return >= .
mkmat annual_return, matrix(r_mat)

**
* main simulation
**

drop _all
clear mata

set type double, permanently
set more off
set seed 1234
*set seed 4321

global CALC_DIFF = `5'

global GAMMA = `1'
global THETA = `2'

global PHI_0 = `4'
global PHI_1 = `3'

*global PHI_0 = -0.02025
*global PHI_1 = -0.1
*global PHI_0 = -0.0405
*global PHI_1 = -0.2

* gamma = 3
global TAU = 0.01
*global TAU = 0.0001

** ratio of H to C2 (C2 in the SICK state!)
global m = 0.236
*global m = 0.341
*global m = 0.99
*global m = 10

** probability of health shock
global p = 0.5


** annual discount rate
global DELTA = 0.027




if ($GAMMA == 1 & $THETA == .2) {
 global DELTA = .0521568238376925
}
if ($GAMMA == 1 & $THETA == .5) {
 global DELTA = .0489656584166853
}
if ($GAMMA == 1 & $THETA == 3) {
 global DELTA = .0227462295761645
}
if ($GAMMA == 3 & $THETA == .2) {
 global DELTA = .0493887708800255
}
if ($GAMMA == 3 & $THETA == .5) {
 global DELTA = .0469668147019719
}
if ($GAMMA == 5 & $THETA == .2) {
 global DELTA = .0469380247128428
}
if ($GAMMA == 5 & $THETA == .5) {
 global DELTA = .0454379628461737
}
if ($GAMMA == 5 & $THETA == 3) {
 global DELTA = .0330207371504982
}




***********
* eps->0
***********
if ($GAMMA == 3 & $THETA == 150) {
 *global DELTA = 0
}


** used to compute DELTAS
*global DELTA = 0
if ($GAMMA != 3 | $THETA != 3) {
 **global DELTA = $DTEMP
}


global DELTA_CUM = (1 + $DELTA)^(25) - 1





global b = 0.8513
if ("`6'" != "") {
 global b = 0.5
 **global b = 0.677
 **global b = 0.8513
 if ($THETA == 0.2) {
  **global b = 0.8513
 }
}


** eps = -0.2 * (1 + (1-b)*m) + (1-b)*m
**global EPS = -1/$GAMMA
*global EPS = -0.160
*global EPS = -0.01
global EPS = -0.20

** PHI_2 defined in terms of b, m
**global PHI_2 = (($m)^($GAMMA)) * (1) * (1 - $b)
**global PHI_2 = (($m)^(-1/$EPS)) * (1+$PHI_1_TILDE) * (1-$b)

global PHI_2_TILDE = (($m)^(-1/$EPS)) * (1-($b))
global PHI_1_TILDE = ///
  (1 + $PHI_1) / (1 + $PHI_2_TILDE*($m^(1+1/$EPS)))^((1-$GAMMA)/(1+1/$EPS)-1) - 1
di "$PHI_1_TILDE, $PHI_2_TILDE ..."


global MU_H_b = .
global MU_C2_b = .

if ($PHI_1 != 0 & "`6'" == "") {
 global PHI_1_TILDE = ///
   (1 + 0) /   ///
   (1 + $PHI_2_TILDE*($m^(1+1/$EPS)))^((1-$GAMMA)/(1+1/$EPS)-1)   ///
   - 1
 do phi2
 di "PHI_2: $PHI_2" 

 global PHI_1_TILDE = ///
   (1 + $PHI_1) /   ///
   (1 + $PHI_2_TILDE*($m^(1+1/$EPS)))^((1-$GAMMA)/(1+1/$EPS)-1)   ///
   - 1

 di "$PHI_2, $PHI_2_temp, $PHI_2_TILDE"

 do find

 global PHI_1_TILDE = PHI_1_TILDE
 global PHI_2_TILDE = PHI_2_TILDE

 di "$PHI_1, $PHI_1_TILDE, $PHI_2, $PHI_2_TILDE ..."

 do compute
}

if ($PHI_1 != 0) {
 ** kaboom
}


** Turn on for optimal insurance
if ("`6'" != "") {
 global b = `6'
 if ("`7'" != "") {
  global PHI_0 = `7'
  global PHI_1_TILDE = `8'
  global PHI_2_TILDE = `9'
 }
}

global Y = 1

**local N = 1
local N = 1000
**local N = 1
set obs `N'

*gen r_cum = (1+uniform()*0.12-0.01)^25
*gen r_cum = (1+0.05)^25
*gen r_cum = (1+0.02)^25

gen r_cum = 1
forvalues y = 1/25 {
 capture drop temp
 gen temp = 1 + floor(uniform() * rowsof(r_mat))
 assert temp >= 1 & temp <= 137
 **replace r_cum = r_cum * (1 + r_mat[temp, 1])
 replace r_cum = r_cum + r_mat[temp, 1]
}

**replace r_cum = r_cum - 1
**replace r_cum = (1 + 0.0)^25 - 1

summ r_cum, det



global prevTAU = .
forvalues i = 1/200 {
 if ($CALC_DIFF == -1) {
   qui do mata2e_fixed_s
 }
 else {
   qui do mata2e
 }
 local h2 = H2_sick0[1,1]
 global U   = U
 global prevTAU = $TAU
 global tau_hat = tau_hat
 global ttt = s_hat
 di "i=`i', TAU=$TAU, tau_hat=$tau_hat, s=$ttt, h=`h2', $U ..."
 if (`i' < 100) {
   **global TAU = $TAU - 0.01 * ((1-$p)*$b*H2_sick0[1,1] - $TAU)
   global TAU = tau_hat
 }
 else {
   global TAU = 0.5*(tau_hat + $prevTAU)
 }
 if(abs(($prevTAU - $TAU)/$TAU) < 1e-4 & ///
    abs($prevTAU - $TAU)        < 1e-5 ) {
  continue, break
 }
}
//assert(abs((1-$p)*$b*`h2' - $TAU) < 1e-4)
//assert(abs((1-$p)*$b*`h2' - $p * $TAU * $ttt) < 1e-4)
assert(abs(($prevTAU - $TAU)/$TAU) < 1e-4 & ///
       abs($prevTAU - $TAU)        < 1e-5) if $ttt > 1e-6

*global TAU = .0758648671239562
*global TAU = $TAU + 0.01
*qui do mata2e
*global U = U

global s = s_hat
global diff = diff
global E_U2 = E_U2
global U2_sick = U2_sick

global MU_H   = MU_H
global MU_C2  = MU_C2
global MU_C2h = MU_C2h
global MU_C1 = MU_C1

exit

















